com.corticon.eclipse.studio.rule.rulesheet.table.core

## Interface IRulesheetTableModelAPI

- All Superinterfaces:
    IModelAPI, IRulesheetModelAPI, com.corticon.rulebuilder.IScopeUtilities

      public interface IRulesheetTableModelAPI
      extends IRulesheetModelAPI

  Rulesheet Table Model API contains methods needed to query and manipulate Rulesheet model objects from the perspective of the Decision Table presentation metaphor.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `CELL_EDITOR_CHECKBOX` Identifier for checkbox cell editor.
    `static int` | `CELL_EDITOR_COMBO` Identifier for combo cell editor.
    `static int` | `CELL_EDITOR_MULTILINE_TEXT` Identifier for multi-line text cell editor.
    `static int` | `CELL_EDITOR_MULTISELECT_COMBO` Identifier for multi-select combo cell editor.
    `static int` | `CELL_EDITOR_TEXT` Identifier for text cell editor.
    `static int` | `COLUMN_COUNT_ACTIONS` Matrix identifiers: column count for actions table.
    `static int` | `COLUMN_COUNT_CONDITIONS` Matrix identifiers: column count for condition table.
    `static int` | `COLUMN_COUNT_FILTERS` Matrix identifiers: column count for filters table.
    `static int` | `COLUMN_COUNT_LOCALIZATION_LOCALE` Matrix identifiers: column count for localization locale table.
    `static int` | `COLUMN_COUNT_RULESTATEMENT` Matrix identifiers: column count for rule statement table.
    `static int` | `COLUMN_INDEX_ACTION_EXPRESSION` Matrix identifiers: action expression.
    `static int` | `COLUMN_INDEX_ACTION_VALUES` Matrix identifiers: action values.
    `static int` | `COLUMN_INDEX_CONDITION_EXPRESSION` Column identifiers: condition expression.
    `static int` | `COLUMN_INDEX_CONDITION_VALUES` Matrix identifiers: condition values.
    `static int` | `COLUMN_INDEX_FILTER_EXPRESSION` Matrix identifiers: column filter expression.
    `static int` | `COLUMN_INDEX_LOCALIZATION_ACTIONS_EXPRESSION` Matrix identifiers: column index for localization actions expression.
    `static int` | `COLUMN_INDEX_LOCALIZATION_CONDITIONS_EXPRESSION` Matrix identifiers: column index for localization conditions expression.
    `static int` | `COLUMN_INDEX_LOCALIZATON_LOCALE` Matrix identifiers: column index for localization table locale.
    `static int` | `COLUMN_INDEX_RULE_NONCONDITIONAL` Matrix identifiers: column index of the non-conditional rule.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_ALIAS` Matrix identifiers: column index for rule statement alias.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_CATEGORY` Matrix identifiers: column index for rule statement category.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_COMMENTS` Matrix identifiers: column index for rule statement comments.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_ID` Matrix identifiers: column index for rule statement id.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_POST_SEVERITY` Matrix identifiers: column index for rule statement post severity.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_REFERENCE` Matrix identifiers: column index for rule statement reference.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_RULE_LINK` Matrix identifiers: column index for rule statement rule link.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_RULE_NAME` Matrix identifiers: column index for rule statement rule name.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_SOURCE_LINK` Matrix identifiers: column index for rule statement source link.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_SOURCE_NAME` Matrix identifiers: column index for rule statement source name.
    `static int` | `COLUMN_INDEX_RULE_STATEMENT_TEXT` Matrix identifiers: column index for rule statement text.
    `static int` | `DISABLE` Constant to identify the job of Disable action.
    `static int` | `ENABLE` Constant to identify the job of Disable action.
    `static int` | `ENABLED_DISABLED_POST` Constant to identify the envelop icon type for Enabled / Disabled Post.
    `static int` | `ICON_SCOPE_ASSOCIATION_MANY_TO_MANY` Scope icon identifiers: Association (many-to-many)
    `static int` | `ICON_SCOPE_ASSOCIATION_MANY_TO_MANY_LIGHT` Scope icon identifiers: Association (many-to-many light)
    `static int` | `ICON_SCOPE_ASSOCIATION_MANY_TO_ONE` Scope icon identifiers: Association (many-to-one)
    `static int` | `ICON_SCOPE_ASSOCIATION_MANY_TO_ONE_LIGHT` Scope icon identifiers: Association (many-to-one light)
    `static int` | `ICON_SCOPE_ASSOCIATION_ONE_TO_MANY` Scope icon identifiers: Association (one-to-many)
    `static int` | `ICON_SCOPE_ASSOCIATION_ONE_TO_MANY_LIGHT` Scope icon identifiers: Association (one-to-many light)
    `static int` | `ICON_SCOPE_ASSOCIATION_ONE_TO_ONE` Scope icon identifiers: Association (one-to-one)
    `static int` | `ICON_SCOPE_ASSOCIATION_ONE_TO_ONE_LIGHT` Scope icon identifiers: Association (one-to-one light)
    `static int` | `ICON_SCOPE_ATTRIBUTE` Scope icon identifiers: Attribute.
    `static int` | `ICON_SCOPE_ATTRIBUTE_EXTENDED_PERSISTENT` Scope icon identifiers: Attribute (extended persistent).
    `static int` | `ICON_SCOPE_ATTRIBUTE_EXTENDED_TRANSIENT` Scope icon identifiers: Attribute (extended transient).
    `static int` | `ICON_SCOPE_ENTITY` Scope icon identifiers: Entity.
    `static int` | `ICON_SCOPE_FILTER` Scope icon identifiers: Filter.
    `static int` | `ICON_SCOPE_FILTER_DISABLED` Scope icon identifiers: Filter (disabled).
    `static int` | `ICON_SCOPE_FILTER_PRECONDITION` Scope icon identifiers: Precondition.
    `static int` | `ICON_SCOPE_FILTERS_FOLDER` Scope icon identifiers: Filters folder.
    `static int` | `ICON_SCOPE_SORTED_ALIAS` Scope icon identifiers: Sorted alias
    `static int` | `MATRIX_ID_ACTIONS` Matrix identifiers: actions table.
    `static int` | `MATRIX_ID_CONDITIONS` Matrix identifiers: conditions.
    `static int` | `MATRIX_ID_FILTER` Matrix identifiers: filter table.
    `static int` | `MATRIX_ID_IF` Matrix identifiers: if table.
    `static int` | `MATRIX_ID_LOCALIZATION_LOCALE` Matrix identifiers: localization - locale table.
    `static int` | `MATRIX_ID_LOCALIZATION_RULESTATEMENT` Matrix identifiers: localization - rule statement table.
    `static int` | `MATRIX_ID_LOCALIZATION_SCOPE_ALIAS` Matrix identifiers: localization - scope alias table.
    `static int` | `MATRIX_ID_NATURAL_LANGUAGE_ACTIONS` Matrix identifiers: natural language actions.
    `static int` | `MATRIX_ID_NATURAL_LANGUAGE_CONDITIONS` Matrix identifiers: natural language conditions.
    `static int` | `MATRIX_ID_OVERRIDES` Matrix identifiers: overrides table.
    `static int` | `MATRIX_ID_RULESTATEMENT` Matrix identifiers: rule statement table.
    `static int` | `MATRIX_ID_THEN` Matrix identifiers: then table.
    `static int` | `MULTIPLE_DISABLED_POST` Constant to identify the envelop icon type for Multiple Disabled Post.
    `static int` | `MULTIPLE_ENABLED_POST` Constant to identify the envelop icon type for Multiple Enabled Post.
    `static int` | `NO_ENABLED_DISABLED_POST` Constant to identify the envelop icon type for Enabled / Disabled Post.
    `static int` | `ROW_INDEX_OVERRIDES` Matrix identifiers: row index overrides.
    `static java.lang.String` | `SET_ALL_INDICATOR` Matrix identifiers: hard coded set all indicator value.
    `static int` | `SINGLE_DISABLED_POST` Constant to identify the envelop icon type for Single Disabled Post.
    `static int` | `SINGLE_ENABLED_POST` Constant to identify the envelop icon type for Single Enabled Post.
    `static int` | `TREEVIEW_ID_SCOPE` Tree identifiers: scope.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `addActionRowsToEnd()` Add rows to the end of the action section.
    `boolean` | `addConditionRowsToEnd()` Add rows to the end of the condition section.
    `boolean` | `addFilterRowsToEnd()` Add rows to the end of the filter section.
    `boolean` | `addRuleColumnsToEnd()` Add columns to the end of the rule section.
    `boolean` | `addRuleStatementRowsToEnd()` Add rows to the end of the rule statement section.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAssociation` | `addScopeAssociation(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, org.eclipse.emf.ecore.EReference aEReference)` Deprecated. Clean up of ModelAPI for EMF parameter objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAssociation` | `addScopeAssociation(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, IAssociationEnd aIAssociationEnd)` Add a new association to the Scope section.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAttribute` | `addScopeAttribute(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, org.eclipse.emf.ecore.EAttribute aEAttribute)` Deprecated. Clean up of ModelAPI for EMF parameter objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAttribute` | `addScopeAttribute(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, IAttribute aIAttribute)` Add a new attribute to the Scope section.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeEntity` | `addScopeEntity(org.eclipse.emf.ecore.EClass aEClass)` Deprecated. Clean up of ModelAPI for EMF parameter objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeEntity` | `addScopeEntity(IEntity aIEntity)` Add a new entity to the Scope section.
    `java.util.List<com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode>` | `addScopeNodes(java.util.List<IElement> aListIElement)` Given a List of Vocabulary IElement instances, ensure that those elements are represented in the Scope section.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeSortedAlias` | `addScopeSortedAlias(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAttribute aScopeAttribute, java.lang.String operatorID)` Add a new sorted alias node to the scope section.
    `void` | `adjustRuleStatementReferences(boolean abDelete, boolean abColumn, int aiBegin, int aiCount)` Adjust all Rule Statement identifiers to compensate for rule column or action row insertions/deletions.
    `void` | `adjustRuleStatementReferences(java.util.Map aMap, boolean abRenumber)` Given a correlation map, update all Rule Statement References fields accordingly.
    `java.lang.String` | `checkForLogicalLoops()` Check for Logical Loops.
    `boolean` | `clearAnalysisResults()` Clear outstanding analysis results (if any).
    `int` | `convertRowIdentifierToRowIndex(int aiMatrixID, java.lang.String astrRowIdentifier)` Given a matrix identifer and a row identifier (e.g., "AA"), return the zero-based index of that row.
    `java.lang.String` | `convertRowIndexToRowIdentifier(int aiMatrixID, int aiRowIndexRelative)` Given a matrix ID and row number, return the corresponding alphabet letter or letters for the identifier column, starting with "A" and doubling letters if more than 26 are needed (e.g., "AA").
    `Rectangle` | `convertRuleStatementRangeExpressionToRectangle(java.lang.String astrRangeExpression)` Convert the given rule statement range expression to a Rectangle representing the range.
    `java.lang.String` | `convertRuleStatementRectangleToRangeExpression(Rectangle aRectangle)` Convert the given Rectangle to a corresponding range expression.
    `void` | `copy(Selection aSelection)` Copy the selection to the system clipboard.
    `org.jdom.Document` | `createDefaultXmlReport(boolean abAddReportHeader)` Creates an XML Document that can be used for reporting purposes.
    `void` | `createDependecyGraph()` Create the dependency graph.
    `void` | `createExecutionGraph()` Create the execution graph.
    `void` | `cut(Selection aSelection)` Cut the selection to the system clipboard.
    `void` | `delete(Selection aSelection)` Delete the selected area.
    `boolean` | `deleteActionRows(int aiRowIndex, int aiRowCount)` Delete one or more action rows.
    `boolean` | `deleteActionRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more action rows.
    `boolean` | `deleteColumns(int aiMatrixID, int aiColumnIndex, int aiColumnCount)` Delete one or more columns from the specified matrix.
    `boolean` | `deleteColumns(int aiMatrixID, int aiColumnIndex, int aiColumnCount, boolean abReduceCount)` Delete one or more columns from the specified matrix.
    `boolean` | `deleteConditionRows(int aiRowIndex, int aiRowCount)` Delete one or more condition rows.
    `boolean` | `deleteConditionRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more condition rows.
    `boolean` | `deleteFilterRows(int aiRowIndex, int aiRowCount)` Delete one or more Filter rows.
    `boolean` | `deleteFilterRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more Filter rows.
    `boolean` | `deleteLocalizationLocaleRows(int aiRowIndex, int aiRowCount)` Delete one or more Localization locale rows.
    `boolean` | `deleteLocalizationLocaleRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more Localization locale rows.
    `boolean` | `deleteRows(int aiMatrixID, int aiRowIndex, int aiRowCount)` Delete one or more rows from the specified matrix.
    `boolean` | `deleteRows(int aiMatrixID, int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more rows from the specified matrix.
    `boolean` | `deleteRuleColumnInternal(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleColumn aRuleColumnDeleted)` Delete the specified RuleColumn instance and all of its subordinate Condition and Action value set cells.
    `boolean` | `deleteRuleColumns(int aiRuleColumnIndex, int aiRuleCount)` Delete one or more rule columns.
    `boolean` | `deleteRuleColumns(int aiRuleColumnIndex, int aiRuleCount, boolean abReduceCount)` Delete one or more rule columns.
    `boolean` | `deleteRuleStatementRows(int aiRowIndex, int aiRowCount)` Delete one or more Rule Statement rows.
    `boolean` | `deleteRuleStatementRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more Rule Statement rows.
    `boolean` | `disableActionRow(int aiRowIndex, boolean abDisable)` Enables/Disables a specific Action (view model & canonical model) based on the `disable` state.
    `boolean` | `disableActionsRow(boolean abDisable)` Enables/Disables all the Actions (view model & canonical model) based on the `disable` state.
    `boolean` | `disableAllRuleStatements(boolean abDisable)` Enables/Disables all RuleStatements (canonical model) in RuleStatementSection based on the `disable` state.
    `boolean` | `disableConditionRow(int aiRowIndex, boolean abDisable)` Enables/Disables a specific Condition (view model & canonical model) based on the `disable` state.
    `boolean` | `disableConditionsRow(boolean abDisable)` Enables/Disables all the Conditions (view model & canonical model) based on the `disable` state.
    `boolean` | `disableEnableBasedOnSelection(Selection aSelection, boolean abDisable)` Based on what is selected, disable the appropriate rows, columns or objects.
    `boolean` | `disableFilter(int aiRowIndex, boolean abDisable)` Enables/Disables a specific Filter (canonical model) based on the `disable` state.
    `boolean` | `disableRuleActionCell(int aiColumnIndex, int aiRowIndex, boolean abDisable)` Enable or disable a single Rule Action cell.
    `boolean` | `disableRuleColumn(int aiColumnIndex, boolean abDisable)` Find the RuleColumn based on the column index and Enables/Disables PRule and all Condition and Action items within the PRule.
    `boolean` | `disableRuleStatement(int aiRowIndex, boolean abDisable)` Enables/Disables a specific Rule Statement.
    `boolean` | `disableScopeFilter(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter aScopeFilter, boolean abDisable)` Enables/disabled the specified ScopeFilter.
    `boolean` | `expandRuleColumn(int aiRuleColumnIndex, int aiSubruleCount)` Expand the specified rule column to add the specified number of subrules.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ActionSection` | `findActionSection()` Finder for ActionSection.
    `java.util.List<com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias>` | `findAllScopeAlias(IEntity aIEntity, com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aStartNode)`
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ConditionSection` | `findConditionSection()` Finder for ConditionSection.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.DecisionTable` | `findDecisionTable()` Finder for DecisionTable.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.FilterSection` | `findFilterSection()` Finder for FilterSection.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleColumn` | `findRuleColumn(java.lang.String astrRuleId)` Finder for RuleColumn
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleColumn` | `findRuleColumnFirst(java.lang.String astrRuleId)` Finder for first Rule Column that matches the specified Rule ID (integer portion).
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleColumn` | `findRuleColumnLast(java.lang.String astrRuleId)` Finder for last Rule Column that matches the specified Rule ID (integer portion).
    `java.util.List` | `findRuleColumns(java.lang.String astrRuleId)` Finder for all Rule columns that share the same integer rule ID.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleSection` | `findRuleSection()` Finder for RuleSection.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleStatementSection` | `findRuleStatementSection()` Finder for RuleStatementSection.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias` | `findScopeAlias(java.lang.String astrEntity, java.lang.String astrAlias, com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aStartNode)` Find entity or association in scope tree with given name and/or alias
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAttribute` | `findScopeAttribute(java.lang.String aName, com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aStartNode)` Find attribute in scope section with given name
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter` | `findScopeFilter(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFolder aScopeFolder, java.lang.String aFilter)` Find scope filter under scope folder
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFolder` | `findScopeFolder(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias)` Find scope folder under given node (any folder)
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeSection` | `findScopeSection()` Finder for ScopeSection.
    `java.lang.String` | `formatActionConsummation(java.lang.String astrExpression, ValueSet aValueSet)` Given an Action string and an action ValueSet instance, format and return a valid assignment expression that can be used to update the canonical model.
    `java.lang.String` | `formatConditionConsummation(java.lang.String astrExpression, ValueSet aValueSet, int aiRowIndex)` Given a Condition String and a ValueSet instance, format and return a valid relational expression that can be used to update the canonical model.
    `int` | `getActionDisableRole(Selection aSelection)` Determine whether the action should perform enable or disable function.
    `java.lang.String` | `getCardinalitiesString(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAssociation aScopeAssociation)` Return the "cardinalities" string representation for a given instance of ScopeAssociaton: 1->1 (one-to-one) 1->* (one-to-many) *->1 (many-to-one) *->* (many-to-many)
    `int` | `getCellEditorType(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Return an integer number representing the type of cell editor to use to edit the specified cell.
    `java.lang.String` | `getCellNaturalLanguageText(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Get the natural language text associated with the specified cell, if any.
    `java.lang.Object` | `getCellValue(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Get the Rulesheet cell value from the specified matrix, row and column index.
    `java.lang.Object` | `getCellValue(int aiMatrixID, int aiColumnIndex, int aiRowIndex, boolean abBase)` Get the Rulesheet cell value from the specified matrix, row and column index.
    `int` | `getColumnCountActual(int aiMatrixID)` Return the number of columns currently used in specified matrix.
    `int` | `getColumnCountDisplayed(int aiMatrixID)` Return the number of column displayed in the specified matrix.
    `int` | `getColumnHorizontalAlignment(int aiMatrixID, int aiColumnIndex)` Returns the recommended column horizontal alignment for a matrix column.
    `java.util.List` | `getConditionValueSet(int aiRowIndex)` Return a list of values for a given condition row.
    `IElement` | `getFacade(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Find a facade for the specified scope node.
    `java.util.List` | `getListCellItems(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Get a list of values available for the specified Rulesheet cell.
    `java.util.List` | `getListIfCell(int aiColumnIndex, int aiRowIndex)` Return a list of items used to populate the "if" cell combo box.
    `java.util.List` | `getListOverridesCell(int aiColumnIndex)` Return a list of items used to populate the "overrides" cell combo box.
    `java.util.List` | `getListRuleStatementAlias()` Return a list used to populate the Rule Statement matrix Alias combo box.
    `java.util.List` | `getListRuleStatementPostSeverity()` Return a list used to populate the Rule Statement "Post" combo box.
    `java.util.List` | `getListThenCell(int aiColumnIndex, int aiRowIndex)` Return a list of items used to populate the "then" cell combo box.
    `MatrixRepaintRequest` | `getMatrixRepaintRequest(int aiMatrixID, org.eclipse.emf.common.notify.Notification aNotification)` Get a MatrixRepaintRequest request that describes the area of a table to be repainted for a given EMF model change notification.
    `java.lang.String` | `getOperatorDropExpression(com.corticon.rulesemf.operationsmodel.OperatorNode aOperatorNode)` Given an Operator Node instance, return the proper drop expression for that node.
    `java.lang.String` | `getOperatorName(java.lang.String astrOperatorID, boolean abBase)` Get the base or localized operator name corresponding to the specified operator ID.
    `int` | `getPostMessagesStatus(int iColIndex, int iRowIndex)` Identifies the messages posted for the particular Rule Column and returns the envelop type to show.
    `int` | `getRowCountActual(int aiMatrixID)` Return the number of rows currently used in specified matrix.
    `int` | `getRowCountDisplayed(int aiMatrixID)` Return the number of rows displayed in the specified matrix.
    `int` | `getRowHeight(int aiMatrixID, int aiRowIndex)` Get the height of the specified row.
    `int` | `getRuleColumnWidth(int aiRuleColumnIndex)` Get the width of a rule column.
    `java.lang.String` | `getRuleIdForColumn(int aiRuleColumnIndex)` Given a rule column index, return the rule ID for that column in non-localized (base) form.
    `java.lang.String` | `getRuleIdForColumn(int aiRuleColumnIndex, boolean abBase)` Given a rule column index, return the rule ID for that column (either base or localized form depending on parameter abBase).
    `int` | `getRuleScrollColumnLeft()` Get the rule section scroll column left.
    `int` | `getSashWeightAdvancedView()` Returns the value of the sash weight for Advanced View.
    `int` | `getSashWeightConditionsActions()` Returns the value of the sash weight for Conditions/Actions Section.
    `int` | `getSashWeightConditionsIf()` Returns the value of the sash weight for Conditions/If Section.
    `int` | `getSashWeightScope()` Returns the value of the sash weight for Scope Section.
    `java.lang.String` | `getScopeDropExpression(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Given a particular ScopeNode it returns the expression to drop in a Rulesheet cell.
    `java.lang.String` | `getScopeNodeAliasName(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias)` Given a ScopeAlias node instance, return the alias name (localized value).
    `java.lang.String` | `getScopeNodeAliasNameBase(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias)` Given a ScopeAlias node instance, return the alias name (base value).
    `java.lang.String` | `getScopeNodeAliasNameLocalized(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias)` Given a ScopeAlias node instance, return the alias name (localized name).
    `java.util.List` | `getScopeNodeChildren(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Get a list of children of the specified scope node as necessary to render the Scope Tree view.
    `java.util.List` | `getScopeNodeChildren(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, boolean abReturnAttributes)` Get a list of children of the specified scope node as necessary to render the Scope Tree view.
    `int` | `getScopeNodeIcon(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Given a ScopeNode instance, return an integer constant corresponding to the icon to be displayed (e.g., IRulesheetTableModelAPI.ICON_SCOPE_ENTITY).
    `java.lang.String` | `getScopeNodeName(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Given a ScopeNode instance, return the name (localized value).
    `java.lang.String` | `getScopeNodeNameBase(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Given a ScopeNode instance, return the name (base value).
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode` | `getScopeNodeParent(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Get the parent of the specified ScopeNode instance as necessary to render the Scope Tree view.
    `java.lang.String` | `getScopeNodeText(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Given a ScopeNode instance, return localized text to be displayed adjacent to the icon in the Scope tree.
    `int` | `getScrollRowTop(int aiMatrixID)` Get the index of the top row that is currently displayed in the specified matrix.
    `Selection` | `getSelection()` Return the current selection state of the Rulesheet.
    `java.lang.String` | `getToolTip(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Get the tool tip at the specified coordinates.
    `java.lang.String` | `getVocabularyDropExpression(java.util.List aList)` Prepares a localized drop expression based on list of Vocabulary facades.
    `boolean` | `hasDatabase(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Return true if the ScopeNode is database bound and should be represented in the tree with a database decoration.
    `boolean` | `hasErrors(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is has any errors.
    `boolean` | `hasErrors(int aiMatrixID, int aiColumnIndex, int aiRowIndex, boolean abDemotion)` Determine whether the specified cell is has any errors.
    `boolean` | `hasErrors(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, boolean abRecursive)` Return true if the ScopeNode has errors.
    `boolean` | `hasErrors(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, boolean abRecursive, boolean abDemotion)` Return true if the ScopeNode has errors.
    `boolean` | `hasErrorsOrWarnings(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is has any errors or warnings.
    `boolean` | `hasErrorsOrWarnings(int aiMatrixID, int aiColumnIndex, int aiRowIndex, boolean abDemotion)` Determine whether the specified cell is has any errors or warnings.
    `boolean` | `hasWarnings(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is has any warnings.
    `boolean` | `hasWarnings(int aiMatrixID, int aiColumnIndex, int aiRowIndex, boolean abDemotion)` Determine whether the specified cell is has any warnings.
    `boolean` | `hasWarnings(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, boolean abRecursive)` Return true if the ScopeNode has warnings.
    `boolean` | `hasWarnings(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, boolean abRecursive, boolean abDemotion)` Return true if the ScopeNode has warnings.
    `boolean` | `insertActionRows(int aiRowIndex, int aiRowCount)` Insert one or more action rows.
    `boolean` | `insertConditionRows(int aiRowIndex, int aiRowCount)` Insert one or more condition rows.
    `boolean` | `insertFilterRows(int aiRowIndex, int aiRowCount)` Insert one or more Filter rows.
    `boolean` | `insertRows(int aiMatrixID, int aiRowIndex, int aiRowCount)` Insert rows into the specified matrix.
    `boolean` | `insertRuleColumnInternal(int aiRuleColumnIndex, java.lang.String astrRuleId)` Insert a single rule column at the specified index.
    `boolean` | `insertRuleColumns(int aiRuleColumnIndex, int aiRuleCount)` Insert one or more rule columns.
    `boolean` | `insertRuleStatementRows(int aiRowIndex, int aiRowCount)` Insert one or more Rule Statement rows.
    `boolean` | `isAdvanceViewVisible()` Return current state of the AdvanceView.
    `boolean` | `isAllowedDropScope(java.lang.Object aObjectSource, java.lang.Object aObjectTarget)` Determine whether the specified Scope section drop is allowable.
    `boolean` | `isAmbiguityFilterOn()` Determine whether Conflict filter is ON.
    `boolean` | `isAssignmentActionExpression(int aiRowIndex)` Return `true` if the given action expression cell is valid and represents a complete action expression.
    `boolean` | `isAttributeReference(int aiRowIndex, boolean abThen)` Return `true` if the given expression cell has a single attribute term.
    `boolean` | `isBooleanActionExpression(int aiRowIndex)` Return `true` if the given action expression cell is valid and represents a boolean action expression.
    `boolean` | `isBooleanConditionExpression(int aiRowIndex)` Return `true` if the given condition expression cell is valid and represents a boolean condition expression.
    `boolean` | `isCellDisabled(int iMatrixID, int iColIndex, int iRowIndex)` Returns `true`, if a cell in Conditions or Actions or IF or THEN or Filters or RuleStatement matrix is disabled, `false` otherwise.
    `boolean` | `isCellEditable(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Return indication of whether the specified table cell editor should allow the user to enter text into the control.
    `boolean` | `isCellEmpty(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Return and indication of whether the specified cell is empty or null.
    `boolean` | `isCellNaturalLanguageTextSet(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell has an associated Natural Language values associated with it.
    `boolean` | `isCellProtected(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Return an indication of whether the cell is protected (i.e., it cannot be edited).
    `boolean` | `isCellRuleStatementHighlighted(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell should be subject to rule-statement-highlighting.
    `boolean` | `isCellSelected(Selection aSelection)` Returns `true`, if a cell in any matrix is selected, `false` otherwise.
    `boolean` | `isCellValid(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is valid, specifically, that the cell is free of any error-level messages.
    `boolean` | `isCellValid(int aiMatrixID, int aiColumnIndex, int aiRowIndex, boolean abDemotion)` Determine whether the specified cell is valid, specifically, that the cell is free of any error-level messages that haven't been demoted.
    `boolean` | `isCollectionConditionExpression(int aiRowIndex)` Return `true` if the given condition expression is a collection call.
    `boolean` | `isColumnEmpty(int aiMatrixID, int aiColumnIndex)` Return and indication of whether the specified column is entirely empty.
    `boolean` | `isColumnSelected(Selection aSelection)` Returns `true`, if a column in any matrix is selected, `false` otherwise.
    `boolean` | `isEnabledAddColumnsToEnd(Selection aSelection)` Determine whether add columns to end function should be enabled.
    `boolean` | `isEnabledAddRowsToEnd(Selection aSelection)` Determine whether add rows to end function should be enabled.
    `boolean` | `isEnabledCheckForLogicalLoops(Selection aSelection)` Determine whether check for logical loops function is enabled.
    `boolean` | `isEnabledClearAnalysisResults()` Determine whether clear analysis results function is enabled.
    `boolean` | `isEnabledCopy(Selection aSelection)` Determine whether copy function is enabled.
    `boolean` | `isEnabledCut(Selection aSelection)` Determine whether cut function is enabled.
    `boolean` | `isEnabledDelete(Selection aSelection)` Determine whether delete function is enabled.
    `boolean` | `isEnabledDeleteColumn(Selection aSelection)` Determine whether delete column function is enabled.
    `boolean` | `isEnabledDeleteRow(Selection aSelection)` Determine whether delete row function is enabled.
    `boolean` | `isEnabledDisable(Selection aSelection)` Determine whether disable function is enabled.
    `boolean` | `isEnabledExtendToDatabase(Selection aSelection)` Determine whether extend to database action should be enabled.
    `boolean` | `isEnabledFilterDatabase(Selection aSelection)` Determine whether the "database filter" function is enabled.
    `boolean` | `isEnabledFilterMinimum(Selection aSelection)` Deprecated. Minimum filters have been superseded by discrete filters.
    `boolean` | `isEnabledFilterPrecondition(Selection aSelection)` Determine whether the "precondition" function is enabled.
    `boolean` | `isEnabledInsertColumn(Selection aSelection)` Determine whether insert column function is enabled.
    `boolean` | `isEnabledInsertRow(Selection aSelection)` Determine whether insert row function is enabled.
    `boolean` | `isEnabledLocalize()` Determine whether Localize function is enabled.
    `boolean` | `isEnabledNaturalLanguageEditorContextMenuAction()` Determine whether Natural Language action is enabled for a rulesheet.
    `boolean` | `isEnabledPaste(Selection aSelection)` Determine whether paste function is enabled.
    `boolean` | `isEnabledProcessThreshold(Selection aSelection)` Determine whether "Use Conditions as a processing Threshold" function is enabled.
    `boolean` | `isEnabledRenumberRules(Selection aSelection)` Determine whether renumber rules function is enabled.
    `boolean` | `isEnabledReport()` Determine whether report function is enabled.
    `boolean` | `isEnabledSelectAll()` Determine whether select all function is enabled.
    `boolean` | `isFilterDatabase(int aiRowIndex)` Determine whether the specified filter row is a database filter.
    `boolean` | `isFilterMinimum(int aiRowIndex)` Deprecated. Minimum filters have been superseded by discrete filters.
    `boolean` | `isFilterPrecondition(int aiRowIndex)` Determine whether the specified filter row is a precondition
    `boolean` | `isNaturalLanguageView()` Determine whether Natural Language view is enabled.
    `boolean` | `isRowEmpty(int aiMatrixID, int aiRowIndex)` Return and indication of whether the specified row is entirely empty.
    `boolean` | `isRuleColumnAddedByCompletenessCheck(int aiColumnIndex)` Return `true` if the specified rule column was added by the completeness check service.
    `boolean` | `isRuleColumnAmbiguous(int aiColumnIndex)` Return `true` if the specified rule column is currently flagged as ambiguous.
    `boolean` | `isRuleColumnHeaderBold(int aiColumnIndex)` Return `true` if the specified rule column heading should be rendered in bold.
    `boolean` | `isRuleMatrix(int aiMatrixID)` Determine whether the specified matrix is one of the rule matrices, specifically "if", "then" or "overrides".
    `boolean` | `isScopeNodeExpanded(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Determine whether the specified ScopeNode instance is expanded.
    `boolean` | `isScopeNodeFilterDisabledGlobally(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter aScopeFilter)` Determine whether the specified ScopeFilter instance should be rendered as disabled in the scope tree viewer because the filter row is completely disabled.
    `boolean` | `isScopeNodeFilterDisabledIndependently(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter aScopeFilter)` Determine whether the specified ScopeFilter instance is disabled independently.
    `boolean` | `isScopeNodeFilterLeaf(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter aScopeFilter)` Identify whether the given ScopeFilter is a leaf-most filter node in the ScopeNode hierarchy.
    `boolean` | `isScopeNodeInherited(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Determine whether the specified ScopeNode instance is inherited.
    `boolean` | `isScopeNodeNameLightGray(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Determine whether the specified Scope node name should be rendered in light gray text.
    `boolean` | `isScopeNodeQualified(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Determine whether the specified ScopeNode instance is a qualified association.
    `boolean` | `isScopeNodeScopeFilterDisabled(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Determine whether the specified ScopeNode instance is a ScopeFilter.isDisabled().
    `boolean` | `isScopeNodeScopeFilterMinimum(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Deprecated. Minimum filters have been superseded by discrete filters.
    `boolean` | `isScopeNodeScopeFilterPrecondition(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Determine whether the specified ScopeNode instance is a ScopeFilter.isPrecondition().
    `boolean` | `isValidRuleStatementReference(java.lang.String astrReference)` Determine whether the the given Rule Statement Reference is of valid syntax.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ActionValueSetCell` | `makeActionValueSetCell(java.lang.String astrValue)` Factory method to create a valid ActionValueSetCell from a string.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ConditionValueSetCell` | `makeConditionValueSetCell(java.lang.String astrValue)` Factory method to create a valid ConditionValueSetCell from a string.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ExpressionCell` | `makeExpressionCell(java.lang.String astrValue)` Factory method to create a valid ExpressionCell from a string.
    `com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ValueSetCell` | `makeValueSetCell(java.lang.String astrValue)` Factory method to create a valid ValueSetCell from a string.
    `void` | `parseAndUpdateAllOverrideCells()` Parse and update all override cells.
    `void` | `parseAndUpdateAllReferenceFields()` Parse and update all reference fields, which at this time includes overrides and Rule Statement references.
    `void` | `parseAndUpdateAllRuleStatementReferenceFields()` Parse and rebuild the canonical model for all Rule Statement Reference (Ref) fields.
    `void` | `parseCell(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Given a matrix ID, column and row indices, parse, semantically analyze and normalize the cell.
    `void` | `paste(Selection aSelection)` Paste the system clipboard into the selected area.
    `void` | `populateIfCellsWithDashes()` Automatically fill in empty MATRIX_ID_IF table cells with dashes.
    `void` | `presave()` Perform any necessary functions prior to saving.
    `void` | `rebuildCanonicalRules()` Completely rebuild all canonical rules using information in the view model.
    `boolean` | `removeScopeNode(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)` Remove an existing node from the Scope section, implicitly deleting all child nodes.
    `boolean` | `removeScopeNodes(Selection aSelection)` Remove all existing node from the Scope section that are contained in the Selection, implicitly deleting all child nodes.
    `boolean` | `renumberRules(Selection aSelection)` Renumber rules on the input selection.
    `void` | `reorderFilterChildren(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFolder aScopeFolder)` Automatically reorder the filter section.
    `void` | `selectAll()` Select all of the cells in the currently-selected matrix.
    `boolean` | `setActionColumnWidthFactor(double adWidthFactor)` Set the actions/values width factor, namely the ratio of the actions column width to the client area width.
    `boolean` | `setActionExpression(int aiRowIndex, java.lang.String astrExpression)` Set the the action expression at the specified row index.
    `boolean` | `setActionRowCount(int aiRowCount)` Set the count of rows in the Actions section.
    `boolean` | `setActionScrollRowTop(int aiRowIndexTop)` Set the action section scroll row top.
    `boolean` | `setActionValues(int aiRowIndex, java.lang.String astrValueSet)` Set the action values at the specified row index.
    `void` | `setAdvanceViewVisible(boolean visible)` Set the visibility of the AdvanceView.
    `boolean` | `setAmbiguityFilter(boolean abFilter)` Sets Conflict filter ON/OFF.
    `boolean` | `setCellValue(int aiMatrixID, int aiColumnIndex, int aiRowIndex, java.lang.Object aObjectValue)` Set the Rulesheet cell value of the specified matrix, row and column index.
    `boolean` | `setCellValue(int aiMatrixID, int aiColumnIndex, int aiRowIndex, java.lang.Object aObjectValue, boolean abBase)` Set the Rulesheet cell value of the specified matrix, row and column index.
    `boolean` | `setColumnCountDisplayed(int aiMatrixID, int aiColumnCount)` Set the number of column displayed in the specified matrix.
    `boolean` | `setConditionAsProcessingThreshold(int aiColumn, boolean abSet)` Set condition as processing threshold for a given rule column
    `boolean` | `setConditionColumnWidthFactor(double adWidthFactor)` Set the conditions/values width factor, namely the ratio of the conditions column width to the total column width.
    `boolean` | `setConditionExpression(int aiRowIndex, java.lang.String astrExpression)` Set the the condition expression at the specified row index.
    `boolean` | `setConditionRowCount(int aiRowCount)` Set the count of rows in the Conditions section.
    `boolean` | `setConditionsAsProcessingThreshold()` Toggle selected condition columns as processing threshold.
    `boolean` | `setConditionScrollRowTop(int aiRowIndexTop)` Set the conditions section scroll row top.
    `boolean` | `setConditionValues(int aiRowIndex, java.lang.String astrValueSet)` Set the condition values at the specified row index.
    `boolean` | `setFilterDatabase(int aiRowIndex, boolean abFilterDatabase)` Sets the Filter database indicator for the specified row index.
    `boolean` | `setFilterExpression(int aiRowIndex, java.lang.String astrExpression)` Sets the Filter expression for the specified row index.
    `boolean` | `setFilterMinimum(int aiRowIndex, boolean abMinimum)` Deprecated. Minimum filters have been superseded by discrete filters.
    `boolean` | `setFilterPrecondition(int aiRowIndex, boolean abPrecondition)` Sets the Filter precondition indicator for the specified row index.
    `boolean` | `setFilterRowCount(int aiRowCount)` Set the count of rows in the Filter section.
    `boolean` | `setFilterScrollRowTop(int aiRowIndexTop)` Set the Filter section scroll row top.
    `boolean` | `setLocalizationLanguageCode(int aiRowIndex, java.lang.String astrLanguageCode)` Set the localization view language code.
    `boolean` | `setLocalizationRuleStatementText(int aiColumnIndex, int aiRowIndex, java.lang.String astrText)` Set the localization view rule statement text.
    `boolean` | `setLocalizationScopeAlias(int aiColumnIndex, int aiRowIndex, java.lang.String astrText)` Set the localization view scope alias.
    `boolean` | `setNaturalLanguageAction(int aiColumnIndex, int aiRowIndex, java.lang.String astrText)` Set the specified natural language action cell.
    `boolean` | `setNaturalLanguageCondition(int aiColumnIndex, int aiRowIndex, java.lang.String astrText)` Set the specified natural language condition cell.
    `void` | `setNaturalLanguageView(boolean abNaturalLanguageView)` Set the Natural Language view state.
    `boolean` | `setRowCountDisplayed(int aiMatrixID, int aiRowCount)` Set the number of rows displayed in the specified matrix.
    `boolean` | `setRowHeight(int aiMatrixID, int aiRowIndex, int aiRowHeight)` Set the height of the specified row.
    `boolean` | `setRuleActionCell(int aiColumnIndex, int aiRowIndex, java.lang.String astrValueSet)` Set the rule action ("then") cell at the specified column and row indices.
    `boolean` | `setRuleActionCellInternal(int aiColumnIndex, int aiRowIndex, ValueSet aValueSet, boolean abCanonical)` Set the rule action ("then") cell at the specified column and row indices.
    `boolean` | `setRuleColumnCount(int aiColumnCount)` Set the count of rule columns.
    `boolean` | `setRuleColumnWidth(int aiRuleColumnIndex, int aiWidth)` Set the width of a rule column.
    `boolean` | `setRuleColumnWidthAutoSize(int aiRuleColumnIndex)` Set the width of a rule column with auto-sizing.
    `boolean` | `setRuleConditionCell(int aiColumnIndex, int aiRowIndex, java.lang.String astrValueSet)` Set the rule condition ("if") cell at the specified column and row indices.
    `boolean` | `setRuleConditionCellInternal(int aiColumnIndex, int aiRowIndex, ValueSet aValueSet, boolean abCanonical)` Set the rule condition ("if") cell at the specified column and row indices.
    `boolean` | `setRuleIDs(java.lang.String[] astrRuleIDArray)` Set the rule identifiers from a caller-supplied array.
    `boolean` | `setRuleOverrideCell(int aiColumnIndex, java.lang.String astrValueSet)` Set the rule override cell at the specified column index.
    `boolean` | `setRuleOverrideCellInternal(int aiColumnIndex, ValueSet aValueSet, boolean abCanonical)` Set the rule override cell at the specified column index.
    `boolean` | `setRuleScrollColumnLeft(int aiColumnIndexLeft)` Set the rule section scroll column left.
    `boolean` | `setRuleStatementAlias(int aiRowIndex, java.lang.String astrAlias)` Set the rule statement Alias for the specified row index.
    `boolean` | `setRuleStatementCategory(int aiRowIndex, java.lang.String astrCategory)` Set the rule statement Category for the specified row index.
    `boolean` | `setRuleStatementColumnWidthAlias(int aiWidth)` Set the rule statement Alias column width.
    `boolean` | `setRuleStatementColumnWidthCategory(int aiWidth)` Set the rule statement Category column width.
    `boolean` | `setRuleStatementColumnWidthComments(int aiWidth)` Set the rule statement Comments column width.
    `boolean` | `setRuleStatementColumnWidthID(int aiWidth)` Set the rule statement ID column width.
    `boolean` | `setRuleStatementColumnWidthPostSeverity(int aiWidth)` Set the rule statement Post Severity column width.
    `boolean` | `setRuleStatementColumnWidthReference(int aiWidth)` Set the rule statement Reference column width.
    `boolean` | `setRuleStatementColumnWidthRuleLink(int aiWidth)` Set the rule statement Rule Link column width.
    `boolean` | `setRuleStatementColumnWidthRuleName(int aiWidth)` Set the rule statement Rule Name column width.
    `boolean` | `setRuleStatementColumnWidthSourceLink(int aiWidth)` Set the rule statement Source Link column width.
    `boolean` | `setRuleStatementColumnWidthSourceName(int aiWidth)` Set the rule statement Source Name column width.
    `boolean` | `setRuleStatementColumnWidthText(int aiWidth)` Set the rule statement Text column width.
    `boolean` | `setRuleStatementComments(int aiRowIndex, java.lang.String astrComments)` Set the rule statement Comments for the specified row index.
    `boolean` | `setRuleStatementID(int aiRowIndex, java.lang.String astrID)` Sets the rule statement ID for the specified row index.
    `boolean` | `setRuleStatementPostSeverity(int aiRowIndex, com.corticon.rulesemf.canonicalrulemodel.rulesheet.MessageSeverity aMessageSeverity)` Deprecated. - Should use setRuleStatementPostSeverity(int, String)
    `boolean` | `setRuleStatementPostSeverity(int aiRowIndex, java.lang.String astrBaseSeverityName)` Sets the rule statement Post Severity for the specified row index.
    `boolean` | `setRuleStatementReference(int aiRowIndex, java.lang.String astrReference)` Sets the rule statement Reference for the specified row index.
    `boolean` | `setRuleStatementRowCount(int aiRowCount)` Set the count of rows in the Rule Statement section.
    `boolean` | `setRuleStatementRuleLink(int aiRowIndex, java.lang.String astrRuleLink)` Set the rule statement Rule Link for the specified row index.
    `boolean` | `setRuleStatementRuleName(int aiRowIndex, java.lang.String astrRuleName)` Set the rule statement Rule Name for the specified row index.
    `boolean` | `setRuleStatementScrollRowTop(int aiRowIndexTop)` Set the rule statement section scroll row top.
    `boolean` | `setRuleStatementSourceLink(int aiRowIndex, java.lang.String astrSourceLink)` Set the rule statement Source Link for the specified row index.
    `boolean` | `setRuleStatementSourceName(int aiRowIndex, java.lang.String astrSourceName)` Set the rule statement Source Name for the specified row index.
    `boolean` | `setRuleStatementText(int aiRowIndex, java.lang.String astrText)` Set the rule statement Text for the specified row index.
    `void` | `setSashWeightAdvancedView(int aiNewSashWeightAdvancedView)` Sets the value of the sash weight for Advanced View.
    `void` | `setSashWeightConditionsActions(int aiNewSashWeightConditionsActions)` Sets the value of the sash weight for Conditions/Actions Section.
    `void` | `setSashWeightConditionsIf(int aiNewSashWeightConditionsIf)` Sets the value of the sash weight for Conditions/If Section.
    `void` | `setSashWeightScope(int aiNewSashWeightScope)` Sets the value of the sash weight for Scope Section.
    `boolean` | `setScopeAlias(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias, java.lang.String astrAlias)` Set the Scope alias in a given ScopeAlias node.
    `boolean` | `setScopeExtendToDatabase(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeEntity aScopeEntity, boolean abExtendToDatabase)` Set the Scope extend to database flag.
    `boolean` | `setScopeNodeAliasName(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias, java.lang.String astrAlias)` Set the Scope alias for a given ScopeAlias node.
    `boolean` | `setScopeNodeExpanded(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode, boolean abExpanded)` Sets the value of expanded attribute of the specified ScopeNode instance.
    `boolean` | `setScrollRowTop(int aiMatrixID, int aiRowIndexTop)` Set the index of the top row that is currently displayed in the specified matrix.
    `boolean` | `setSelection(Selection aSelection)` Set the selection state.

    - ### Methods inherited from interface com.corticon.eclipse.studio.rule.rulesheet.core.IRulesheetModelAPI

      `addAction, addCondition, addFilter, addLogicalVariable, addLogicalVariable, addLogicalVariable, addLogicalVariable, addReferencedAttribute, addRule, addRuleStatement, createAction, createCondition, createFilter, createRule, createRulesheet, createRuleStatement, deleteRulesheet, findEntity, findLogicalVariable, findLogicalVariableImplicit, findRuleset, findRulesheetAsset, getAliasUtilities, getAllLogicalVariables, getConvertedAliasName, getLogicalVariablePath, getNewRulesheetName, getNextAvailableAliasName, getNextAvailableConvertedAliasName, getOperationsModelAPI, getParser, getRulebuilderFactory, getSemanticAnalysis, getTotalNumberOfRules, getVocabulary, getVocabularyModelAPI, getVocabularyURI, insertAction, insertCondition, insertRule, isDatabaseAccessEnabled, isDatabaseEnabled, isDeployable, isFilterDatabaseReady, isProcessAllLogicalLoops, isProcessMultiRuleLogicalLoops, isVocabularyAvailable, makeOpaqueExpression, makeRulesheetString, removeAction, removeCondition, removeFilter, removeLogicalVariable, removeReferencedAttribute, removeRule, removeRuleStatement, renameRulesheet, setActionExpression, setConditionExpression, setFilterExpression, setLocalizationLogicalVariableName, setLocalizationRuleStatementText, setLogicalLoopEnabled, setLogicalVariableExtendToDatabase, setLogicalVariableName, setLogicalVariableQualifier, setProcessAllLogicalLoops, setProcessMultiRuleLogicalLoops, setRuleOverrides, setRuleStatementAlias, setRuleStatementCategory, setRuleStatementComments, setRuleStatementID, setRuleStatementPostSeverity, setRuleStatementRuleLink, setRuleStatementRuleModelElements, setRuleStatementRuleName, setRuleStatementSourceLink, setRuleStatementSourceName, setRuleStatementText, setVocabulary`

    - ### Methods inherited from interface com.corticon.eclipse.core.IModelAPI

      `activate, addAnnotation, addBatchedModelListener, addLowLevelModelListener, addModelListener, addResourceListener, addView, beginTransaction, cancelTransaction, canSetSupportedLocales, closeResource, createResource, deleteAnnotation, deleteAnnotation, deleteAnnotation, deleteResource, displayMessageBox, dispose, doPostLoadValidation, doSmartValidation, endTransaction, endTransaction, flushCommandStack, formatValidationMessageLocation, formatValidationMessageText, getAllLocalesProvidingCompleteLocalization, getAnnotation, getAnnotations, getAnnotations, getAnnotations, getAPIContextObject, getAsset, getBaseAttribute, getBaseAttributeString, getBatchedModelListeners, getBuildNumber, getBuildNumberOfLastValidationRulesChange, getEditingDomain, getErrors, getErrors, getIndexByLocale, getLocale, getLocalizedAttribute, getLocalizedAttributeString, getLowLevelModelListeners, getMajorServiceNumber, getMajorVersionNumber, getMessage, getMessage, getMessageBase, getMessageBoxDelegate, getMinorServiceNumber, getMinorVersionNumber, getModelAPIState, getModelListeners, getNewResourceName, getPersistenceServicesDelegate, getPreferences, getPrimaryResource, getPrimaryResourceURI, getScrollableMessageDelegate, getSupportedLocales, getSuppressBrokenLinkValidation, getSuppressValidation, getToolTip, getUpdateStamp, getUserInterfaceInfoDelegate, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessages, getValidationMessages, getWarnings, getWarnings, handleException, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, isAPIStateEstablished, isEnabledRedo, isEnabledUndo, isInhibitNotification, isLoaded, isOperationModeNormal, isOperationModeRedo, isOperationModeUndo, isPassive, isPostLoadInProgress, isPrimaryResourceSet, isReadOnly, isResourceActivated, isResourceConflict, isResourceDemandLoaded, isResourceLoaded, isScrollableMessageDelegateAvailable, isShowCanonicalValidationMessages, isSuppressModifiedFlagUpdates, isSuppressPostLoad, isTransactionInProgress, isValid, isValid, loadResource, loadResource, loadResource, newInstance, noOperation, postLoad, postMethod, postMethod, postsave, preMethod, redo, reloadResource, remapResource, remapResource, removeBatchedModelListener, removeLowLevelModelListener, removeModelListener, removeResource, removeResourceListener, removeView, renameResource, rollbackTransaction, saveAll, saveResource, setAnnotation, setAPIContextObject, setAPIState, setBuildNumber, setEditingDomain, setInhibitNotification, setLocale, setMajorServiceNumber, setMajorVersionNumber, setMessageBoxDelegate, setMinorServiceNumber, setMinorVersionNumber, setModelAPIState, setModelListeners, setPassive, setPersistenceServicesDelegate, setPostLoadInProgress, setPreferencesDelegate, setPrimaryResource, setReadOnly, setScrollableMessageDelegate, setSupportedLocales, setSuppressBrokenLinkValidation, setSuppressModifiedFlagUpdates, setSuppressPostLoad, setSuppressValidation, setUserInterfaceInfoDelegate, undo, unloadResource, validate, validateLicense`

    - ### Methods inherited from interface com.corticon.rulebuilder.IScopeUtilities

      `getAttributeDataType, getAttributeDataTypeSubType, getFullyQualifiedEntityName, getMethodDataType, getMethodParamTypes, getRoleDataType, getRoleMultiplicity, isAttributeMandatory, isEntityByName, isExternalEntityByName, isRoleOfEntity, isSubTypeOf, isValidEntityAttribute, isValidEntityMethod`

- - ### Field Detail

    - #### TREEVIEW_ID_SCOPE

          static final int TREEVIEW_ID_SCOPE

      Tree identifiers: scope.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_CONDITIONS

          static final int MATRIX_ID_CONDITIONS

      Matrix identifiers: conditions.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_IF

          static final int MATRIX_ID_IF

      Matrix identifiers: if table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_ACTIONS

          static final int MATRIX_ID_ACTIONS

      Matrix identifiers: actions table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_THEN

          static final int MATRIX_ID_THEN

      Matrix identifiers: then table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_RULESTATEMENT

          static final int MATRIX_ID_RULESTATEMENT

      Matrix identifiers: rule statement table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_FILTER

          static final int MATRIX_ID_FILTER

      Matrix identifiers: filter table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_OVERRIDES

          static final int MATRIX_ID_OVERRIDES

      Matrix identifiers: overrides table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_LOCALIZATION_LOCALE

          static final int MATRIX_ID_LOCALIZATION_LOCALE

      Matrix identifiers: localization - locale table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_LOCALIZATION_SCOPE_ALIAS

          static final int MATRIX_ID_LOCALIZATION_SCOPE_ALIAS

      Matrix identifiers: localization - scope alias table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_LOCALIZATION_RULESTATEMENT

          static final int MATRIX_ID_LOCALIZATION_RULESTATEMENT

      Matrix identifiers: localization - rule statement table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_NATURAL_LANGUAGE_CONDITIONS

          static final int MATRIX_ID_NATURAL_LANGUAGE_CONDITIONS

      Matrix identifiers: natural language conditions.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_NATURAL_LANGUAGE_ACTIONS

          static final int MATRIX_ID_NATURAL_LANGUAGE_ACTIONS

      Matrix identifiers: natural language actions.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_CONDITION_EXPRESSION

          static final int COLUMN_INDEX_CONDITION_EXPRESSION

      Column identifiers: condition expression.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_CONDITION_VALUES

          static final int COLUMN_INDEX_CONDITION_VALUES

      Matrix identifiers: condition values.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_ACTION_EXPRESSION

          static final int COLUMN_INDEX_ACTION_EXPRESSION

      Matrix identifiers: action expression.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_ACTION_VALUES

          static final int COLUMN_INDEX_ACTION_VALUES

      Matrix identifiers: action values.
      See Also:
        Constant Field Values

    - #### ROW_INDEX_OVERRIDES

          static final int ROW_INDEX_OVERRIDES

      Matrix identifiers: row index overrides.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_FILTER_EXPRESSION

          static final int COLUMN_INDEX_FILTER_EXPRESSION

      Matrix identifiers: column filter expression.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_REFERENCE

          static final int COLUMN_INDEX_RULE_STATEMENT_REFERENCE

      Matrix identifiers: column index for rule statement reference.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_ID

          static final int COLUMN_INDEX_RULE_STATEMENT_ID

      Matrix identifiers: column index for rule statement id.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_POST_SEVERITY

          static final int COLUMN_INDEX_RULE_STATEMENT_POST_SEVERITY

      Matrix identifiers: column index for rule statement post severity.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_ALIAS

          static final int COLUMN_INDEX_RULE_STATEMENT_ALIAS

      Matrix identifiers: column index for rule statement alias.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_TEXT

          static final int COLUMN_INDEX_RULE_STATEMENT_TEXT

      Matrix identifiers: column index for rule statement text.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_RULE_NAME

          static final int COLUMN_INDEX_RULE_STATEMENT_RULE_NAME

      Matrix identifiers: column index for rule statement rule name.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_RULE_LINK

          static final int COLUMN_INDEX_RULE_STATEMENT_RULE_LINK

      Matrix identifiers: column index for rule statement rule link.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_SOURCE_NAME

          static final int COLUMN_INDEX_RULE_STATEMENT_SOURCE_NAME

      Matrix identifiers: column index for rule statement source name.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_SOURCE_LINK

          static final int COLUMN_INDEX_RULE_STATEMENT_SOURCE_LINK

      Matrix identifiers: column index for rule statement source link.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_CATEGORY

          static final int COLUMN_INDEX_RULE_STATEMENT_CATEGORY

      Matrix identifiers: column index for rule statement category.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_STATEMENT_COMMENTS

          static final int COLUMN_INDEX_RULE_STATEMENT_COMMENTS

      Matrix identifiers: column index for rule statement comments.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_LOCALIZATON_LOCALE

          static final int COLUMN_INDEX_LOCALIZATON_LOCALE

      Matrix identifiers: column index for localization table locale.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_LOCALIZATION_CONDITIONS_EXPRESSION

          static final int COLUMN_INDEX_LOCALIZATION_CONDITIONS_EXPRESSION

      Matrix identifiers: column index for localization conditions expression.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_LOCALIZATION_ACTIONS_EXPRESSION

          static final int COLUMN_INDEX_LOCALIZATION_ACTIONS_EXPRESSION

      Matrix identifiers: column index for localization actions expression.
      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_RULE_NONCONDITIONAL

          static final int COLUMN_INDEX_RULE_NONCONDITIONAL

      Matrix identifiers: column index of the non-conditional rule.
      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_CONDITIONS

          static final int COLUMN_COUNT_CONDITIONS

      Matrix identifiers: column count for condition table.
      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_ACTIONS

          static final int COLUMN_COUNT_ACTIONS

      Matrix identifiers: column count for actions table.
      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_RULESTATEMENT

          static final int COLUMN_COUNT_RULESTATEMENT

      Matrix identifiers: column count for rule statement table.
      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_LOCALIZATION_LOCALE

          static final int COLUMN_COUNT_LOCALIZATION_LOCALE

      Matrix identifiers: column count for localization locale table.
      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_FILTERS

          static final int COLUMN_COUNT_FILTERS

      Matrix identifiers: column count for filters table.
      See Also:
        Constant Field Values

    - #### SET_ALL_INDICATOR

          static final java.lang.String SET_ALL_INDICATOR

      Matrix identifiers: hard coded set all indicator value.
      See Also:
        Constant Field Values

    - #### CELL_EDITOR_TEXT

          static final int CELL_EDITOR_TEXT

      Identifier for text cell editor.
      See Also:
        Constant Field Values

    - #### CELL_EDITOR_COMBO

          static final int CELL_EDITOR_COMBO

      Identifier for combo cell editor.
      See Also:
        Constant Field Values

    - #### CELL_EDITOR_MULTISELECT_COMBO

          static final int CELL_EDITOR_MULTISELECT_COMBO

      Identifier for multi-select combo cell editor.
      See Also:
        Constant Field Values

    - #### CELL_EDITOR_CHECKBOX

          static final int CELL_EDITOR_CHECKBOX

      Identifier for checkbox cell editor.
      See Also:
        Constant Field Values

    - #### CELL_EDITOR_MULTILINE_TEXT

          static final int CELL_EDITOR_MULTILINE_TEXT

      Identifier for multi-line text cell editor.
      See Also:
        Constant Field Values

    - #### DISABLE

          static final int DISABLE

      Constant to identify the job of Disable action.
      See Also:
        Constant Field Values

    - #### ENABLE

          static final int ENABLE

      Constant to identify the job of Disable action.
      See Also:
        Constant Field Values

    - #### NO_ENABLED_DISABLED_POST

          static final int NO_ENABLED_DISABLED_POST

      Constant to identify the envelop icon type for Enabled / Disabled Post.
      See Also:
        Constant Field Values

    - #### SINGLE_ENABLED_POST

          static final int SINGLE_ENABLED_POST

      Constant to identify the envelop icon type for Single Enabled Post.
      See Also:
        Constant Field Values

    - #### MULTIPLE_ENABLED_POST

          static final int MULTIPLE_ENABLED_POST

      Constant to identify the envelop icon type for Multiple Enabled Post.
      See Also:
        Constant Field Values

    - #### SINGLE_DISABLED_POST

          static final int SINGLE_DISABLED_POST

      Constant to identify the envelop icon type for Single Disabled Post.
      See Also:
        Constant Field Values

    - #### MULTIPLE_DISABLED_POST

          static final int MULTIPLE_DISABLED_POST

      Constant to identify the envelop icon type for Multiple Disabled Post.
      See Also:
        Constant Field Values

    - #### ENABLED_DISABLED_POST

          static final int ENABLED_DISABLED_POST

      Constant to identify the envelop icon type for Enabled / Disabled Post.
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ENTITY

          static final int ICON_SCOPE_ENTITY

      Scope icon identifiers: Entity.
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ATTRIBUTE

          static final int ICON_SCOPE_ATTRIBUTE

      Scope icon identifiers: Attribute.
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ATTRIBUTE_EXTENDED_TRANSIENT

          static final int ICON_SCOPE_ATTRIBUTE_EXTENDED_TRANSIENT

      Scope icon identifiers: Attribute (extended transient).
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ATTRIBUTE_EXTENDED_PERSISTENT

          static final int ICON_SCOPE_ATTRIBUTE_EXTENDED_PERSISTENT

      Scope icon identifiers: Attribute (extended persistent).
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ASSOCIATION_ONE_TO_ONE

          static final int ICON_SCOPE_ASSOCIATION_ONE_TO_ONE

      Scope icon identifiers: Association (one-to-one)
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ASSOCIATION_ONE_TO_MANY

          static final int ICON_SCOPE_ASSOCIATION_ONE_TO_MANY

      Scope icon identifiers: Association (one-to-many)
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ASSOCIATION_MANY_TO_ONE

          static final int ICON_SCOPE_ASSOCIATION_MANY_TO_ONE

      Scope icon identifiers: Association (many-to-one)
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ASSOCIATION_MANY_TO_MANY

          static final int ICON_SCOPE_ASSOCIATION_MANY_TO_MANY

      Scope icon identifiers: Association (many-to-many)
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_FILTER

          static final int ICON_SCOPE_FILTER

      Scope icon identifiers: Filter.
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_FILTER_DISABLED

          static final int ICON_SCOPE_FILTER_DISABLED

      Scope icon identifiers: Filter (disabled).
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_FILTER_PRECONDITION

          static final int ICON_SCOPE_FILTER_PRECONDITION

      Scope icon identifiers: Precondition.
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_FILTERS_FOLDER

          static final int ICON_SCOPE_FILTERS_FOLDER

      Scope icon identifiers: Filters folder.
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_SORTED_ALIAS

          static final int ICON_SCOPE_SORTED_ALIAS

      Scope icon identifiers: Sorted alias
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ASSOCIATION_ONE_TO_ONE_LIGHT

          static final int ICON_SCOPE_ASSOCIATION_ONE_TO_ONE_LIGHT

      Scope icon identifiers: Association (one-to-one light)
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ASSOCIATION_ONE_TO_MANY_LIGHT

          static final int ICON_SCOPE_ASSOCIATION_ONE_TO_MANY_LIGHT

      Scope icon identifiers: Association (one-to-many light)
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ASSOCIATION_MANY_TO_ONE_LIGHT

          static final int ICON_SCOPE_ASSOCIATION_MANY_TO_ONE_LIGHT

      Scope icon identifiers: Association (many-to-one light)
      See Also:
        Constant Field Values

    - #### ICON_SCOPE_ASSOCIATION_MANY_TO_MANY_LIGHT

          static final int ICON_SCOPE_ASSOCIATION_MANY_TO_MANY_LIGHT

      Scope icon identifiers: Association (many-to-many light)
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### addActionRowsToEnd

          boolean addActionRowsToEnd()

      Add rows to the end of the action section.
      Returns:
        `true` if the set command was successful.

    - #### addConditionRowsToEnd

          boolean addConditionRowsToEnd()

      Add rows to the end of the condition section.
      Returns:
        `true` if the set command was successful.

    - #### addFilterRowsToEnd

          boolean addFilterRowsToEnd()

      Add rows to the end of the filter section.
      Returns:
        `true` if the set command was successful.

    - #### addRuleColumnsToEnd

          boolean addRuleColumnsToEnd()

      Add columns to the end of the rule section.
      Returns:
        `true` if the set command was successful.

    - #### addRuleStatementRowsToEnd

          boolean addRuleStatementRowsToEnd()

      Add rows to the end of the rule statement section.
      Returns:
        `true` if the set command was successful.

    - #### addScopeAssociation

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAssociation addScopeAssociation(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                                                                                                         org.eclipse.emf.ecore.EReference aEReference)

      Deprecated. Clean up of ModelAPI for EMF parameter objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
      Add a new association to the Scope section.
      Parameters:
        `aScopeNode` - ScopeNode representing entity or association to which new association should be added.
        `aEReference` - EReference metadata from Vocabulary.
      Returns:
        Object added or `null` if command was unsuccessful.

    - #### addScopeAssociation

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAssociation addScopeAssociation(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                                                                                                         IAssociationEnd aIAssociationEnd)

      Add a new association to the Scope section.
      Parameters:
        `aScopeNode` - ScopeNode representing entity or association to which new association should be added.
        `aIAssociationEnd` - IAssociationEnd metadata from Vocabulary.
      Returns:
        Object added or `null` if command was unsuccessful.

    - #### addScopeAttribute

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAttribute addScopeAttribute(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                                                                                                     org.eclipse.emf.ecore.EAttribute aEAttribute)

      Deprecated. Clean up of ModelAPI for EMF parameter objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
      Add a new attribute to the Scope section.
      Parameters:
        `aScopeNode` - ScopeNode representing entity or association to which new attribute should be added.
        `aEAttribute` - EAttribute metadata from Vocabulary.
      Returns:
        Object added or `null` if command was unsuccessful.

    - #### addScopeAttribute

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAttribute addScopeAttribute(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                                                                                                     IAttribute aIAttribute)

      Add a new attribute to the Scope section.
      Parameters:
        `aScopeNode` - ScopeNode representing entity or association to which new attribute should be added.
        `aIAttribute` - IAttribute metadata from Vocabulary.
      Returns:
        Object added or `null` if command was unsuccessful.

    - #### addScopeEntity

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeEntity addScopeEntity(org.eclipse.emf.ecore.EClass aEClass)

      Deprecated. Clean up of ModelAPI for EMF parameter objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
      Add a new entity to the Scope section.
      Parameters:
        `aEClass` - EClass from Vocabulary representing new entity to be added.
      Returns:
        Object added or `null` if command was unsuccessful.

    - #### addScopeEntity

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeEntity addScopeEntity(IEntity aIEntity)

      Add a new entity to the Scope section.
      Parameters:
        `aIEntity` - IEntity from Vocabulary representing new entity to be added.
      Returns:
        Object added or `null` if command was unsuccessful.

    - #### addScopeNodes

          java.util.List<com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode> addScopeNodes(java.util.List<IElement> aListIElement)

      Given a List of Vocabulary IElement instances, ensure that those elements are represented in the Scope section. Any missing elements will be added to the Scope section, unless such addition would conflict with existing Scope nodes.
      Parameters:
        `aListIElement` - List of Vocabulary elements (type IElement).
      Returns:
        List of ScopeNode instances (empty if none were added).

    - #### addScopeSortedAlias

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeSortedAlias addScopeSortedAlias(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAttribute aScopeAttribute,
                                                                                                         java.lang.String operatorID)

      Add a new sorted alias node to the scope section.
      Parameters:
        `aScopeAttribute` - Attribute node which will be the parent of the sorted alias. E.g. if we are adding a sorted alias order->sortedBy(amount), "amount" is the attribute serving as parent.
        `operatorID` - Operator ID (sortedBy or sortedByDesc)
      Returns:
        Newly created ScopeSortedAlias object

    - #### adjustRuleStatementReferences

          void adjustRuleStatementReferences(boolean abDelete,
                                           boolean abColumn,
                                           int aiBegin,
                                           int aiCount)

      Adjust all Rule Statement identifiers to compensate for rule column or action row insertions/deletions.
      Parameters:
        `abDelete` - Operation: `false` for insert, `true` for delete.
        `abColumn` - Row/Column: `false` for action row, `true` for rule column.
        `aiBegin` - The beginning row index or rule identifier to be adjusted either up or down.
        `aiCount` - Number of rows or columns inserted or deleted.

    - #### adjustRuleStatementReferences

          void adjustRuleStatementReferences(java.util.Map aMap,
                                           boolean abRenumber)

      Given a correlation map, update all Rule Statement References fields accordingly. This method is used by the optimizer "compress" function to update the Rule Statement reference fields and also by the renumbering feature.
      Parameters:
        `aMap` - Map relating old and new IDs.
        `abRenumber` - `true` to adjust for renumbering; `false` for compress.

    - #### checkForLogicalLoops

          java.lang.String checkForLogicalLoops()

      Check for Logical Loops.
      Returns:
        The Logical Loop check result string.

    - #### clearAnalysisResults

          boolean clearAnalysisResults()

      Clear outstanding analysis results (if any).
      Returns:
        `true` if the command was successful.

    - #### convertRowIdentifierToRowIndex

          int convertRowIdentifierToRowIndex(int aiMatrixID,
                                           java.lang.String astrRowIdentifier)

      Given a matrix identifer and a row identifier (e.g., "AA"), return the zero-based index of that row.
      Parameters:
        `aiMatrixID` - Matrix ID (MATRIX_ID_CONDITIONS or MATRIX_ID_ACTIONS).
        `astrRowIdentifier` - Row identifier.
      Returns:
        Zero-based row index.

    - #### convertRowIndexToRowIdentifier

          java.lang.String convertRowIndexToRowIdentifier(int aiMatrixID,
                                                        int aiRowIndexRelative)

      Given a matrix ID and row number, return the corresponding alphabet letter or letters for the identifier column, starting with "A" and doubling letters if more than 26 are needed (e.g., "AA").
      Parameters:
        `aiMatrixID` - Matrix ID (MATRIX_ID_CONDITIONS or MATRIX_ID_ACTIONS).
        `aiRowIndexRelative` - Relative row index.
      Returns:
        String identifier for that row.

    - #### convertRuleStatementRangeExpressionToRectangle

          Rectangle convertRuleStatementRangeExpressionToRectangle(java.lang.String astrRangeExpression)

      Convert the given rule statement range expression to a Rectangle representing the range.
      Parameters:
        `astrRangeExpression` - Range expression (e.g, "A", "2", "A0:B8").
      Returns:
        Rectangle representing range.

    - #### convertRuleStatementRectangleToRangeExpression

          java.lang.String convertRuleStatementRectangleToRangeExpression(Rectangle aRectangle)

      Convert the given Rectangle to a corresponding range expression. The values contained within the Rectangle must conform to certain conventions. For example, if the width value equals Integer.MAX_VALUE then the Rectangle will be a "row-only" specification. Likewise, if the height equals Integer.MAX_VALUE, the Rectangle will be assumed to be a "column-only" specification.
      If the width or height values are one, the Rectangle is assumed to represent a single point rather than a range.
      Parameters:
        `aRectangle` - Rectangle representing range or point.
      Returns:
        Range expression as string (e.g, "A", "2", "A0:B8").

    - #### copy

          void copy(Selection aSelection)

      Copy the selection to the system clipboard.
      Parameters:
        `aSelection` - Selection to copy.

    - #### createDefaultXmlReport

          org.jdom.Document createDefaultXmlReport(boolean abAddReportHeader)

      Creates an XML Document that can be used for reporting purposes.
      Parameters:
        `abAddReportHeader` - Determines if the report header will be added to the result document.
      Returns:
        Xml report document.

    - #### createDependecyGraph

          void createDependecyGraph()

      Create the dependency graph.

    - #### createExecutionGraph

          void createExecutionGraph()

      Create the execution graph.

    - #### cut

          void cut(Selection aSelection)

      Cut the selection to the system clipboard.
      Parameters:
        `aSelection` - Selection to cut.

    - #### delete

          void delete(Selection aSelection)

      Delete the selected area.
      Parameters:
        `aSelection` - Selection to delete.

    - #### deleteActionRows

          boolean deleteActionRows(int aiRowIndex,
                                 int aiRowCount)

      Delete one or more action rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteActionRows

          boolean deleteActionRows(int aiRowIndex,
                                 int aiRowCount,
                                 boolean abReduceCount)

      Delete one or more action rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteColumns

          boolean deleteColumns(int aiMatrixID,
                              int aiColumnIndex,
                              int aiColumnCount)

      Delete one or more columns from the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of first column to be deleted.
        `aiRowCount` - Number of columns to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteColumns

          boolean deleteColumns(int aiMatrixID,
                              int aiColumnIndex,
                              int aiColumnCount,
                              boolean abReduceCount)

      Delete one or more columns from the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of first column to be deleted.
        `aiRowCount` - Number of columns to be deleted.
        `abReduceCount` - `true` to reduce the column count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteConditionRows

          boolean deleteConditionRows(int aiRowIndex,
                                    int aiRowCount)

      Delete one or more condition rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteConditionRows

          boolean deleteConditionRows(int aiRowIndex,
                                    int aiRowCount,
                                    boolean abReduceCount)

      Delete one or more condition rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteFilterRows

          boolean deleteFilterRows(int aiRowIndex,
                                 int aiRowCount)

      Delete one or more Filter rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteFilterRows

          boolean deleteFilterRows(int aiRowIndex,
                                 int aiRowCount,
                                 boolean abReduceCount)

      Delete one or more Filter rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteLocalizationLocaleRows

          boolean deleteLocalizationLocaleRows(int aiRowIndex,
                                             int aiRowCount)

      Delete one or more Localization locale rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteLocalizationLocaleRows

          boolean deleteLocalizationLocaleRows(int aiRowIndex,
                                             int aiRowCount,
                                             boolean abReduceCount)

      Delete one or more Localization locale rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteRows

          boolean deleteRows(int aiMatrixID,
                           int aiRowIndex,
                           int aiRowCount)

      Delete one or more rows from the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteRows

          boolean deleteRows(int aiMatrixID,
                           int aiRowIndex,
                           int aiRowCount,
                           boolean abReduceCount)

      Delete one or more rows from the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteRuleColumnInternal

          boolean deleteRuleColumnInternal(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleColumn aRuleColumnDeleted)

      Delete the specified RuleColumn instance and all of its subordinate Condition and Action value set cells. This high-performance function does the minimum possible model-level changes, bypassing all unnecessary processing.
      Parameters:
        `aRuleColumn` - RuleColumn instance to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteRuleColumns

          boolean deleteRuleColumns(int aiRuleColumnIndex,
                                  int aiRuleCount)

      Delete one or more rule columns.
      Parameters:
        `aiRuleColumnIndex` - Column index of first rule column to be deleted.
        `aiRuleCount` - Number of rules to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteRuleColumns

          boolean deleteRuleColumns(int aiRuleColumnIndex,
                                  int aiRuleCount,
                                  boolean abReduceCount)

      Delete one or more rule columns.
      Parameters:
        `aiRuleColumnIndex` - Column index of first rule column to be deleted.
        `aiRuleCount` - Number of rules to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteRuleStatementRows

          boolean deleteRuleStatementRows(int aiRowIndex,
                                        int aiRowCount)

      Delete one or more Rule Statement rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteRuleStatementRows

          boolean deleteRuleStatementRows(int aiRowIndex,
                                        int aiRowCount,
                                        boolean abReduceCount)

      Delete one or more Rule Statement rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### disableActionRow

          boolean disableActionRow(int aiRowIndex,
                                 boolean abDisable)

      Enables/Disables a specific Action (view model & canonical model) based on the `disable` state.
      Parameters:
        `aiRowIndex` - index of a action row to enable/disable
        `abDisable` - `true` to disable action, `false` to enable a action
      Returns:
        `true` if the state changed operation was successful.

    - #### disableActionsRow

          boolean disableActionsRow(boolean abDisable)

      Enables/Disables all the Actions (view model & canonical model) based on the `disable` state.
      Parameters:
        `abDisable` - `true` to disable action, `false` to enable a action
      Returns:
        `true` if the state changed operation was successful.

    - #### disableAllRuleStatements

          boolean disableAllRuleStatements(boolean abDisable)

      Enables/Disables all RuleStatements (canonical model) in RuleStatementSection based on the `disable` state.
      Parameters:
        `abDisable` - `true` to disable RuleStatement, `false` to enable a RuleStatement
      Returns:
        `true` if the state changed operation was successful.

    - #### disableConditionRow

          boolean disableConditionRow(int aiRowIndex,
                                    boolean abDisable)

      Enables/Disables a specific Condition (view model & canonical model) based on the `disable` state.
      Parameters:
        `aiRowIndex` - index of a condition row to enable/disable
        `abDisable` - `true` to disable condition, `false` to enable a condition
      Returns:
        `true` if the state changed operation was successful.

    - #### disableConditionsRow

          boolean disableConditionsRow(boolean abDisable)

      Enables/Disables all the Conditions (view model & canonical model) based on the `disable` state.
      Parameters:
        `abDisable` - `true` to disable condition, `false` to enable a condition
      Returns:
        `true` if the state changed operation was successful.

    - #### disableEnableBasedOnSelection

          boolean disableEnableBasedOnSelection(Selection aSelection,
                                              boolean abDisable)

      Based on what is selected, disable the appropriate rows, columns or objects.
      Parameters:
        `Selection` - the current selection in the Rulesheet.
        `abDisable` - `true` to disable; otherwise, `false` to enable.
      Returns:
        `true` if the state changed operation was successful.

    - #### disableFilter

          boolean disableFilter(int aiRowIndex,
                              boolean abDisable)

      Enables/Disables a specific Filter (canonical model) based on the `disable` state.
      Parameters:
        `aiRowIndex` - index of a filter row to enable/disable
        `abDisable` - `true` to disable filter, `false` to enable a filter
      Returns:
        `true` if the state changed operation was successful.

    - #### disableScopeFilter

          boolean disableScopeFilter(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter aScopeFilter,
                                   boolean abDisable)

      Enables/disabled the specified ScopeFilter.
      Parameters:
        `aScopeFilter` - ScopeFilter to be enabled/disabled.
      Returns:
        `true` if command was successful.

    - #### disableRuleActionCell

          boolean disableRuleActionCell(int aiColumnIndex,
                                      int aiRowIndex,
                                      boolean abDisable)

      Enable or disable a single Rule Action cell.
      Parameters:
        `aiColumnIndex` - Index of RuleColumn.
        `aiRowIndex` - Index of action row.
        `abDisable` - `true` to disable; `false` to enable.
      Returns:
        `true` if the state changed operation was successful.

    - #### disableRuleColumn

          boolean disableRuleColumn(int aiColumnIndex,
                                  boolean abDisable)

      Find the RuleColumn based on the column index and Enables/Disables PRule and all Condition and Action items within the PRule. This method may seem coded a little strangely, remember when making any changes, this method most work correctly on expanded columns. When columns are expanded, all view model cells must be re-parsed, but often the canonical PRules are shared. In such cases we avoid doing unnecessary state changes to the canonical model by first checking whether the needed changes have already been accomplished.
      Parameters:
        `aiColumnIndex` - Index of RuleColumn.
        `abDisable` - `true` to disable Rule Column, `false` to enable a Rule Column.
      Returns:
        `true` if the state changed operation was successful.

    - #### disableRuleStatement

          boolean disableRuleStatement(int aiRowIndex,
                                     boolean abDisable)

      Enables/Disables a specific Rule Statement.
      Parameters:
        `aiRowIndex` - index of a RuleStatement row to enable/disable.
        `abDisable` - `true` to disable Rule Statement, `false` to enable a Rule Statement.
      Returns:
        `true` if the state changed operation was successful.

    - #### expandRuleColumn

          boolean expandRuleColumn(int aiRuleColumnIndex,
                                 int aiSubruleCount)

      Expand the specified rule column to add the specified number of subrules. The existing rule will be retained; hence, the total number of subrules when the operation is complete will be (aiSubruleCount + 1).
      Parameters:
        `aiRuleColumnIndex` - Column index of rule column to be expanded.
        `aiSubruleCount` - Total number of subrules to be added.
      Returns:
        `true` if expand was successful.

    - #### findActionSection

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ActionSection findActionSection()

      Finder for ActionSection.
      Returns:
        Instance of ActionSection.

    - #### findAllScopeAlias

          java.util.List<com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias> findAllScopeAlias(IEntity aIEntity,
                                                                                                                 com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aStartNode)

    - #### findConditionSection

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ConditionSection findConditionSection()

      Finder for ConditionSection.
      Returns:
        Instance of ConditionSection.

    - #### findDecisionTable

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.DecisionTable findDecisionTable()

      Finder for DecisionTable.
      Returns:
        Instance of DecisionTable.

    - #### findFilterSection

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.FilterSection findFilterSection()

      Finder for FilterSection.
      Returns:
        Instance of FilterSection.

    - #### findRuleColumn

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleColumn findRuleColumn(java.lang.String astrRuleId)

      Finder for RuleColumn
      Parameters:
        `astrRuleId` - Rule identifier.
      Returns:
        Instance of RuleColumn or `null`.

    - #### findRuleColumnFirst

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleColumn findRuleColumnFirst(java.lang.String astrRuleId)

      Finder for first Rule Column that matches the specified Rule ID (integer portion).
      Parameters:
        `astrRuleId` - Rule identifier.
      Returns:
        Instance of first RuleColumn that matches integer portion of specified ID or `null`.

    - #### findRuleColumnLast

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleColumn findRuleColumnLast(java.lang.String astrRuleId)

      Finder for last Rule Column that matches the specified Rule ID (integer portion).
      Parameters:
        `astrRuleId` - Rule identifier.
      Returns:
        Instance of last RuleColumn that matches integer portion of specified ID or `null`.

    - #### findRuleColumns

          java.util.List findRuleColumns(java.lang.String astrRuleId)

      Finder for all Rule columns that share the same integer rule ID.
      Parameters:
        `astrRuleId` - Rule identifier.
      Returns:
        List of matching RuleColumn instances.

    - #### findRuleSection

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleSection findRuleSection()

      Finder for RuleSection.
      Returns:
        Instance of RuleSection.

    - #### findRuleStatementSection

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.RuleStatementSection findRuleStatementSection()

      Finder for RuleStatementSection.
      Returns:
        Instance of RuleStatementSection.

    - #### findScopeAlias

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias findScopeAlias(java.lang.String astrEntity,
                                                                                              java.lang.String astrAlias,
                                                                                              com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aStartNode)

      Find entity or association in scope tree with given name and/or alias
      Parameters:
        `astrEntity` - Entity or association name
        `astrAlias` - Entity or association alias
        `aStartNode` - Node to look under
      Returns:

    - #### findScopeAttribute

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAttribute findScopeAttribute(java.lang.String aName,
                                                                                                      com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aStartNode)

      Find attribute in scope section with given name
      Parameters:
        `aName` - Attribute name
        `aStartNode` - Node to look under
      Returns:

    - #### findScopeFilter

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter findScopeFilter(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFolder aScopeFolder,
                                                                                                java.lang.String aFilter)

      Find scope filter under scope folder
      Parameters:
        `aScopeFolder` -
      Returns:

    - #### findScopeFolder

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFolder findScopeFolder(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias)

      Find scope folder under given node (any folder)
      Parameters:
        `aScopeAlias` -
      Returns:

    - #### findScopeSection

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeSection findScopeSection()

      Finder for ScopeSection.
      Returns:
        Instance of ScopeSection.

    - #### formatActionConsummation

          java.lang.String formatActionConsummation(java.lang.String astrExpression,
                                                  ValueSet aValueSet)

      Given an Action string and an action ValueSet instance, format and return a valid assignment expression that can be used to update the canonical model.
      Parameters:
        `astrExpression` - Expression string (Action).
        `aValueSet` - ValueSet instance.
      Returns:
        Valid assignment expression to update canonical model.

    - #### formatConditionConsummation

          java.lang.String formatConditionConsummation(java.lang.String astrExpression,
                                                     ValueSet aValueSet,
                                                     int aiRowIndex)

      Given a Condition String and a ValueSet instance, format and return a valid relational expression that can be used to update the canonical model.
      Parameters:
        `astrExpression` - Expression string (Condition).
        `aValueSet` - ValueSet instance (typically from "IF" table).
        `aiRowIndex` - Index of condition row.
      Returns:
        Valid relational expression to update canonical model.
      Throws:
        `InvalidConditionException`

    - #### getActionDisableRole

          int getActionDisableRole(Selection aSelection)

      Determine whether the action should perform enable or disable function.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `int` ActionDisable.ENABLE to enable the selected item, or ActionDisable.DISABLE to disable the selected item.

    - #### getCardinalitiesString

          java.lang.String getCardinalitiesString(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAssociation aScopeAssociation)

      Return the "cardinalities" string representation for a given instance of ScopeAssociaton: 1->1 (one-to-one) 1->* (one-to-many) *->1 (many-to-one) *->* (many-to-many)
      Parameters:
        `aScopeAssociation` - ScopeAssociation instance.
      Returns:
        Cardinalities string.

    - #### getCellEditorType

          int getCellEditorType(int aiMatrixID,
                              int aiColumnIndex,
                              int aiRowIndex)

      Return an integer number representing the type of cell editor to use to edit the specified cell. Example:
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        Integer representing type of cell editor to use (e.g., CELL_EDITOR_COMBO).

    - #### getCellValue

          java.lang.Object getCellValue(int aiMatrixID,
                                      int aiColumnIndex,
                                      int aiRowIndex)

      Get the Rulesheet cell value from the specified matrix, row and column index.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        Rulesheet cell value (e.g., String, Enumerator).

    - #### getCellValue

          java.lang.Object getCellValue(int aiMatrixID,
                                      int aiColumnIndex,
                                      int aiRowIndex,
                                      boolean abBase)

      Get the Rulesheet cell value from the specified matrix, row and column index. The method may return either a base or localized value.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
        `abBase` - `true` to return non-localized (base) string.
      Returns:
        Rulesheet cell value (String).

    - #### getCellNaturalLanguageText

          java.lang.String getCellNaturalLanguageText(int aiMatrixID,
                                                    int aiColumnIndex,
                                                    int aiRowIndex)

      Get the natural language text associated with the specified cell, if any. If there is no natural language text associated with the cell, return the localized cell value.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
        `abBase` - `true` to return non-localized (base) string.
      Returns:
        Natural language text associated with cell if any.

    - #### getColumnCountActual

          int getColumnCountActual(int aiMatrixID)

      Return the number of columns currently used in specified matrix. The count reflects the number of columns that are actually in the column list as opposed to the displayed number of columns returned by getColumnCountDisplayed().
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_IF).
      Returns:
        Row count.

    - #### getColumnCountDisplayed

          int getColumnCountDisplayed(int aiMatrixID)

      Return the number of column displayed in the specified matrix. The count reflects the number of column to be displayed and may be greater than the number of actual columns present in the matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_IF).
      Returns:
        Row count.

    - #### getColumnHorizontalAlignment

          int getColumnHorizontalAlignment(int aiMatrixID,
                                         int aiColumnIndex)

      Returns the recommended column horizontal alignment for a matrix column.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_IF).
        `aiColumnIndex` - Column index.
      Returns:
        Constant indicating recommended alignment (e.g., COLUMN_HORIZONTAL_ALIGNMENT_CENTER).

    - #### getConditionValueSet

          java.util.List getConditionValueSet(int aiRowIndex)

      Return a list of values for a given condition row.
      Parameters:
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        List of values for Condition.

    - #### getFacade

          IElement getFacade(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Find a facade for the specified scope node.
      Parameters:
        `aScopeNode` - Node for which facade should be retrieved.
      Returns:
        IElement facade.

    - #### getListCellItems

          java.util.List getListCellItems(int aiMatrixID,
                                        int aiColumnIndex,
                                        int aiRowIndex)

      Get a list of values available for the specified Rulesheet cell. This list of values is typically used to populate the items of a combo box or drop-down control.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        List of items (strings) used to populate the drop-down list.

    - #### getListIfCell

          java.util.List getListIfCell(int aiColumnIndex,
                                     int aiRowIndex)

      Return a list of items used to populate the "if" cell combo box.
      Parameters:
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        List of items for combo box.

    - #### getListOverridesCell

          java.util.List getListOverridesCell(int aiColumnIndex)

      Return a list of items used to populate the "overrides" cell combo box.
      Parameters:
        `aiColumnIndex` - Index of column whose override list should be returned.
      Returns:
        List of items for combo box.

    - #### getListRuleStatementAlias

          java.util.List getListRuleStatementAlias()

      Return a list used to populate the Rule Statement matrix Alias combo box.
      Returns:
        List of aliases used to populate Rule Statement matrix alias combo box.

    - #### getListRuleStatementPostSeverity

          java.util.List getListRuleStatementPostSeverity()

      Return a list used to populate the Rule Statement "Post" combo box.
      Returns:
        List of aliases used to populate Rule Statement "Post" combo box.

    - #### getListThenCell

          java.util.List getListThenCell(int aiColumnIndex,
                                       int aiRowIndex)

      Return a list of items used to populate the "then" cell combo box.
      Parameters:
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        List of items for combo box.

    - #### getMatrixRepaintRequest

          MatrixRepaintRequest getMatrixRepaintRequest(int aiMatrixID,
                                                     org.eclipse.emf.common.notify.Notification aNotification)

      Get a MatrixRepaintRequest request that describes the area of a table to be repainted for a given EMF model change notification.
      Parameters:
        `aiMatrixID` - Matrix ID of matrix whose "dirty" state should be determined.
        `aNotification` - EMF model change notification.
      Returns:
        MatrixPaintRequest describing "dirty" rectangle in matrix.

    - #### getOperatorDropExpression

          java.lang.String getOperatorDropExpression(com.corticon.rulesemf.operationsmodel.OperatorNode aOperatorNode)

      Given an Operator Node instance, return the proper drop expression for that node.
      Parameters:
        `aOperatorNode` - OperatorNode instance.
      Returns:
        Localized expression to drop.

    - #### getOperatorName

          java.lang.String getOperatorName(java.lang.String astrOperatorID,
                                         boolean abBase)

      Get the base or localized operator name corresponding to the specified operator ID.
      Parameters:
        `astrOperatorID` - Operator ID.
        `abBase` - `true` to return base value.
      Returns:
        Base or localized operator name.

    - #### getPostMessagesStatus

          int getPostMessagesStatus(int iColIndex,
                                  int iRowIndex)

      Identifies the messages posted for the particular Rule Column and returns the envelop type to show.
      Parameters:
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        int Envelop type indicating the messages posted for the Rule Column

    - #### getRowCountActual

          int getRowCountActual(int aiMatrixID)

      Return the number of rows currently used in specified matrix. The count reflects the number of rows (items) actually used as opposed to the maximum number returned by getRowCount().
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
      Returns:
        Row count.

    - #### getRowCountDisplayed

          int getRowCountDisplayed(int aiMatrixID)

      Return the number of rows displayed in the specified matrix. The count reflects the number of rows to be displayed and may be greater than the number of items in the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
      Returns:
        Row count.

    - #### getRowHeight

          int getRowHeight(int aiMatrixID,
                         int aiRowIndex)

      Get the height of the specified row.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiRowIndex` - Index of row.
      Returns:
        Height of specified row in pixels.

    - #### getRuleColumnWidth

          int getRuleColumnWidth(int aiRuleColumnIndex)

      Get the width of a rule column.
      Parameters:
        `aiRuleColumnIndex` - Rule column index.
      Returns:
        Width of rule column in pixels.

    - #### getRuleIdForColumn

          java.lang.String getRuleIdForColumn(int aiRuleColumnIndex)

      Given a rule column index, return the rule ID for that column in non-localized (base) form. If the column index has a corresponding RuleColumn instance, simply return that RuleColumn's ID. Otherwise, extrapolate what the rule ID for the specified column *would* be if it existed.
      Parameters:
        `aiRuleColumnIndex` - Rule column index.
      Returns:
        Real or "virtual" Rule identifier corresponding to specified column index (base form).

    - #### getRuleIdForColumn

          java.lang.String getRuleIdForColumn(int aiRuleColumnIndex,
                                            boolean abBase)

      Given a rule column index, return the rule ID for that column (either base or localized form depending on parameter abBase). If the column index has a corresponding RuleColumn instance, simply return that RuleColumn's ID. Otherwise, extrapolate what the rule ID for the specified column *would* be if it existed.
      Parameters:
        `aiRuleColumnIndex` - Rule column index.
        `abBase` - `true` to return base value, `false` to return localized.
      Returns:
        Real or "virtual" Rule identifier corresponding to specified column index.

    - #### getRuleScrollColumnLeft

          int getRuleScrollColumnLeft()

      Get the rule section scroll column left.
      Returns:
        Index of left most column displayed in table.

    - #### getSashWeightAdvancedView

          int getSashWeightAdvancedView()

      Returns the value of the sash weight for Advanced View.
      Returns:
        Sash weight value for the Advanced View

    - #### getSashWeightConditionsActions

          int getSashWeightConditionsActions()

      Returns the value of the sash weight for Conditions/Actions Section.
      Returns:
        Sash weight value for the Conditions/Actions Section.

    - #### getSashWeightConditionsIf

          int getSashWeightConditionsIf()

      Returns the value of the sash weight for Conditions/If Section.
      Returns:
        Sash weight value for the Conditions/If Section

    - #### getSashWeightScope

          int getSashWeightScope()

      Returns the value of the sash weight for Scope Section.
      Returns:
        Sash weight value for the Scope Section.

    - #### getScopeDropExpression

          java.lang.String getScopeDropExpression(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Given a particular ScopeNode it returns the expression to drop in a Rulesheet cell.
      Parameters:
        `aScopeNode` - ScopeNode to drop.
      Returns:
        String drop expression.

    - #### getScopeNodeAliasName

          java.lang.String getScopeNodeAliasName(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias)

      Given a ScopeAlias node instance, return the alias name (localized value).
      Parameters:
        `aScopeAlias` - ScopeAlias instance.
      Returns:
        Scope alias name (localized value).

    - #### getScopeNodeAliasNameBase

          java.lang.String getScopeNodeAliasNameBase(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias)

      Given a ScopeAlias node instance, return the alias name (base value).
      Parameters:
        `aScopeAlias` - ScopeAlias instance.
      Returns:
        Scope alias name (base value).

    - #### getScopeNodeAliasNameLocalized

          java.lang.String getScopeNodeAliasNameLocalized(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias)

      Given a ScopeAlias node instance, return the alias name (localized name).
      Parameters:
        `aScopeAlias` - ScopeAlias instance.
      Returns:
        Scope alias name (localized value).

    - #### getScopeNodeChildren

          java.util.List getScopeNodeChildren(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Get a list of children of the specified scope node as necessary to render the Scope Tree view.
      Parameters:
        `aScopeNode` - ScopeNode parent.
      Returns:
        List of Scope nodes (children).

    - #### getScopeNodeChildren

          java.util.List getScopeNodeChildren(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                                            boolean abReturnAttributes)

      Get a list of children of the specified scope node as necessary to render the Scope Tree view.
      Parameters:
        `aScopeNode` - ScopeNode parent.
        `abReturnAttributes` - `true` to return attribute nodes.
      Returns:
        List of Scope nodes (children).

    - #### getScopeNodeIcon

          int getScopeNodeIcon(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Given a ScopeNode instance, return an integer constant corresponding to the icon to be displayed (e.g., IRulesheetTableModelAPI.ICON_SCOPE_ENTITY).
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        Integer constant specifying which icon should be displayed.

    - #### getScopeNodeName

          java.lang.String getScopeNodeName(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Given a ScopeNode instance, return the name (localized value).
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        Scope node name (localized value).

    - #### getScopeNodeNameBase

          java.lang.String getScopeNodeNameBase(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Given a ScopeNode instance, return the name (base value).
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        Scope node name (base value).

    - #### getScopeNodeParent

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode getScopeNodeParent(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Get the parent of the specified ScopeNode instance as necessary to render the Scope Tree view.
      Parameters:
        `aScopeNode` - ScopeNode child.
      Returns:
        ScopeNode parent instance.

    - #### getScopeNodeText

          java.lang.String getScopeNodeText(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Given a ScopeNode instance, return localized text to be displayed adjacent to the icon in the Scope tree.
      Parameters:
        `aScopeNode` - ScopeNode whose text is to be returned.
      Returns:
        Localized text display from Vocabulary node.

    - #### getScrollRowTop

          int getScrollRowTop(int aiMatrixID)

      Get the index of the top row that is currently displayed in the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
      Returns:
        Index of top row displayed in matrix.

    - #### getSelection

          Selection getSelection()

      Return the current selection state of the Rulesheet.
      Returns:
        Selection instance.

    - #### getToolTip

          java.lang.String getToolTip(int aiMatrixID,
                                    int aiColumnIndex,
                                    int aiRowIndex)

      Get the tool tip at the specified coordinates.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        String Tool tip or null if none.

    - #### getVocabularyDropExpression

          java.lang.String getVocabularyDropExpression(java.util.List aList)

      Prepares a localized drop expression based on list of Vocabulary facades. The list (which should consist of instances of type IElement) should start with the Vocabulary root and end with the node being dragged.
      If a probable match of an explicit logical variable (alias) is detected in Scope section, this method will return a drop string that incorporates; otherwise, this method will return an implicit logical variable path.
      Example returns:
      cust.order.item.quantity Order.item.quantity
      Parameters:
        `aList` - List of Vocabulary facades (IElement instances) from root to the dragged node.
      Returns:
        String drop expression.

    - #### hasErrors

          boolean hasErrors(int aiMatrixID,
                          int aiColumnIndex,
                          int aiRowIndex)

      Determine whether the specified cell is has any errors.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell has any errors.

    - #### hasErrors

          boolean hasErrors(int aiMatrixID,
                          int aiColumnIndex,
                          int aiRowIndex,
                          boolean abDemotion)

      Determine whether the specified cell is has any errors.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
        `abDemotion` - `true` to take demotion into account.
      Returns:
        `true` if cell has any errors.

    - #### hasDatabase

          boolean hasDatabase(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Return true if the ScopeNode is database bound and should be represented in the tree with a database decoration.
      Parameters:
        `aScopeNode` - ScopeNode to be tested.
      Returns:
        `true` if ScopeNode should be decorated with database icon.

    - #### hasErrors

          boolean hasErrors(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                          boolean abRecursive)

      Return true if the ScopeNode has errors.
      Parameters:
        `aScopeNode` - ScopeNode to test for errors.
        `abRecursive` - `true` to check recursively for errors in child nodes.
      Returns:
        `true` if scope node has any errors.

    - #### hasErrors

          boolean hasErrors(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                          boolean abRecursive,
                          boolean abDemotion)

      Return true if the ScopeNode has errors.
      Parameters:
        `aScopeNode` - ScopeNode to Scope for errors.
        `abRecursive` - `true` to check recursively for errors in child nodes.
        `abDemotion` - `true` to take demotion into account.
      Returns:
        `true` if scope node has any errors.

    - #### hasErrorsOrWarnings

          boolean hasErrorsOrWarnings(int aiMatrixID,
                                    int aiColumnIndex,
                                    int aiRowIndex)

      Determine whether the specified cell is has any errors or warnings.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell has any errors or warnings.

    - #### hasErrorsOrWarnings

          boolean hasErrorsOrWarnings(int aiMatrixID,
                                    int aiColumnIndex,
                                    int aiRowIndex,
                                    boolean abDemotion)

      Determine whether the specified cell is has any errors or warnings.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
        `abDemotion` - `true` to take demotion into account.
      Returns:
        `true` if cell has any errors or warnings.

    - #### hasWarnings

          boolean hasWarnings(int aiMatrixID,
                            int aiColumnIndex,
                            int aiRowIndex)

      Determine whether the specified cell is has any warnings.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell has any warnings.

    - #### hasWarnings

          boolean hasWarnings(int aiMatrixID,
                            int aiColumnIndex,
                            int aiRowIndex,
                            boolean abDemotion)

      Determine whether the specified cell is has any warnings.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
        `abDemotion` - `true` to take demotion into account.
      Returns:
        `true` if cell has any warnings.

    - #### hasWarnings

          boolean hasWarnings(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                            boolean abRecursive)

      Return true if the ScopeNode has warnings.
      Parameters:
        `aScopeNode` - ScopeNode to test for warnings.
        `abRecursive` - `true` to check recursively for warnings in child nodes.
      Returns:
        `true` if scope node has any warnings.

    - #### hasWarnings

          boolean hasWarnings(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                            boolean abRecursive,
                            boolean abDemotion)

      Return true if the ScopeNode has warnings.
      Parameters:
        `aScopeNode` - ScopeNode to Scope for warnings.
        `abRecursive` - `true` to check recursively for warnings in child nodes.
        `abDemotion` - `true` to take demotion into account.
      Returns:
        `true` if scope node has any warnings.

    - #### insertActionRows

          boolean insertActionRows(int aiRowIndex,
                                 int aiRowCount)

      Insert one or more action rows.
      Parameters:
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### insertConditionRows

          boolean insertConditionRows(int aiRowIndex,
                                    int aiRowCount)

      Insert one or more condition rows.
      Parameters:
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### insertFilterRows

          boolean insertFilterRows(int aiRowIndex,
                                 int aiRowCount)

      Insert one or more Filter rows.
      Parameters:
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### insertRows

          boolean insertRows(int aiMatrixID,
                           int aiRowIndex,
                           int aiRowCount)

      Insert rows into the specified matrix.
      Parameters:
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### insertRuleColumnInternal

          boolean insertRuleColumnInternal(int aiRuleColumnIndex,
                                         java.lang.String astrRuleId)

      Insert a single rule column at the specified index. This high-performance function does the minimum possible model-level changes, bypassing all unnecessary processing.
      Parameters:
        `aiRuleColumnIndex` - Column index of rule column to be inserted.
        `astrRuleId` - Rule identifier to use or `null`.
      Returns:
        `true` if insert was successful.

    - #### insertRuleColumns

          boolean insertRuleColumns(int aiRuleColumnIndex,
                                  int aiRuleCount)

      Insert one or more rule columns.
      Parameters:
        `aiRuleColumnIndex` - Column index of first rule column to be inserted.
        `aiRuleCount` - Number of rules to be inserted.
      Returns:
        `true` if insert was successful.

    - #### insertRuleStatementRows

          boolean insertRuleStatementRows(int aiRowIndex,
                                        int aiRowCount)

      Insert one or more Rule Statement rows.
      Parameters:
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### isAdvanceViewVisible

          boolean isAdvanceViewVisible()

      Return current state of the AdvanceView.
      Returns:
        boolean instance.

    - #### isAllowedDropScope

          boolean isAllowedDropScope(java.lang.Object aObjectSource,
                                   java.lang.Object aObjectTarget)

      Determine whether the specified Scope section drop is allowable.
      Parameters:
        `aObjectSource` - ENamedElement or IElement from Vocabulary.
        `aObjectTarget` - Target Scope object or `null` if no target.
      Returns:
        `true` if drop is allowable.

    - #### isAmbiguityFilterOn

          boolean isAmbiguityFilterOn()

      Determine whether Conflict filter is ON.
      Returns:
        `true` if the filter flag is enabled.

    - #### isAssignmentActionExpression

          boolean isAssignmentActionExpression(int aiRowIndex)

      Return `true` if the given action expression cell is valid and represents a complete action expression. This method can be used to determine if check-box cell renderers are required for "Then" matrix cells.
      Parameters:
        `aiRowIndex` - Index of row whose action cell is to be tested.
      Returns:
        `true` if action expression stands alone.

    - #### isAttributeReference

          boolean isAttributeReference(int aiRowIndex,
                                     boolean abThen)

      Return `true` if the given expression cell has a single attribute term.
      Parameters:
        `aiRowIndex` - Index of row whose action cell is to be scoped.
        `abThen` - `true` for action ("then") cells.
      Returns:
        `true` if expression is an attribute expression.

    - #### isBooleanActionExpression

          boolean isBooleanActionExpression(int aiRowIndex)

      Return `true` if the given action expression cell is valid and represents a boolean action expression. This method can be used to determine if T/F drop-downs are needed for "Then" matrix cells.
      Parameters:
        `aiRowIndex` - Index of row whose action cell is to be tested.
      Returns:
        `true` if action expression is boolean.

    - #### isBooleanConditionExpression

          boolean isBooleanConditionExpression(int aiRowIndex)

      Return `true` if the given condition expression cell is valid and represents a boolean condition expression. This method can be used to determine if T/F drop-downs are needed for "If" matrix cells.
      Parameters:
        `aiRowIndex` - Index of row whose action cell is to be tested.
      Returns:
        `true` if condition expression warrants T/F drop-down list.

    - #### isCellDisabled

          boolean isCellDisabled(int iMatrixID,
                               int iColIndex,
                               int iRowIndex)

      Returns `true`, if a cell in Conditions or Actions or IF or THEN or Filters or RuleStatement matrix is disabled, `false` otherwise.
      Parameters:
        `iMatrixID` - matrix identifier
        `iColIndex` - column index of cell
        `iRowIndex` - row index of cell
      Returns:
        `true`, if a cell in Conditions or Actions or IF or THEN or Filters or RuleStatement matrix is disabled, `false` otherwise.

    - #### isCellEditable

          boolean isCellEditable(int aiMatrixID,
                               int aiColumnIndex,
                               int aiRowIndex)

      Return indication of whether the specified table cell editor should allow the user to enter text into the control. This method is germane only to combo box controls.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiColumnIndex` - Column index of cell whose state is to be tested.
        `aiRowIndex` - Row index of cell whose state is to be tested.
      Returns:
        `true` if cell editor should be directly editable.

    - #### isCellEmpty

          boolean isCellEmpty(int aiMatrixID,
                            int aiColumnIndex,
                            int aiRowIndex)

      Return and indication of whether the specified cell is empty or null. For enumerated values, empty is defined value zero which is reserved for the "unspecified" value (EMF enumerations behave like Java primitives in that they do not support a "null" state).
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiColumnIndex` - Column index of cell whose state is to be tested.
        `aiRowIndex` - Row index of cell whose state is to be tested.
      Returns:
        `true` if the specified cell is empty.

    - #### isCellRuleStatementHighlighted

          boolean isCellRuleStatementHighlighted(int aiMatrixID,
                                               int aiColumnIndex,
                                               int aiRowIndex)

      Determine whether the specified cell should be subject to rule-statement-highlighting. This highlighting graphically depicts the relationship between rule statements and rule cells. It is displayed in rule column cells when the corresponding rule statement row cells are selected; conversely, it is displayed in rule statement row cells when corresponding rule column cells are selected.
      If this method returns `true`, the client program should color the specified cell a color designated for rule-statement-highlighting, typically orange.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_IF).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell contents are valid.

    - #### isCellProtected

          boolean isCellProtected(int aiMatrixID,
                                int aiColumnIndex,
                                int aiRowIndex)

      Return an indication of whether the cell is protected (i.e., it cannot be edited). Protected cells are typically displayed in gray.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiColumnIndex` - Column index of cell whose state is to be tested.
        `aiRowIndex` - Row index of cell whose state is to be tested.
      Returns:
        `true` if the specified cell is protected.

    - #### isCellSelected

          boolean isCellSelected(Selection aSelection)

      Returns `true`, if a cell in any matrix is selected, `false` otherwise.
      Parameters:
        `aSelection` - Selection to test.
      Returns:
        `true` if a cell in any matrix selected.

    - #### isCellValid

          boolean isCellValid(int aiMatrixID,
                            int aiColumnIndex,
                            int aiRowIndex)

      Determine whether the specified cell is valid, specifically, that the cell is free of any error-level messages. Invalid cells are typically rendered in red depending, on UI conventions.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell contents are valid.

    - #### isCellValid

          boolean isCellValid(int aiMatrixID,
                            int aiColumnIndex,
                            int aiRowIndex,
                            boolean abDemotion)

      Determine whether the specified cell is valid, specifically, that the cell is free of any error-level messages that haven't been demoted. Invalid cells are typically rendered in red depending, on UI conventions.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
        `abDemotion` - `true` to take demotion into account.
      Returns:
        `true` if cell contents are valid.

    - #### isCellNaturalLanguageTextSet

          boolean isCellNaturalLanguageTextSet(int aiMatrixID,
                                             int aiColumnIndex,
                                             int aiRowIndex)

      Determine whether the specified cell has an associated Natural Language values associated with it.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell contains a Natural Language value.

    - #### isCollectionConditionExpression

          boolean isCollectionConditionExpression(int aiRowIndex)

      Return `true` if the given condition expression is a collection call. This method can be used to determine if T/F drop-downs are needed for "If" matrix cells.
      Parameters:
        `aiRowIndex` - Index of row whose conditions cell is to be tested.
      Returns:
        `true` if condition is a collection expression.

    - #### isColumnEmpty

          boolean isColumnEmpty(int aiMatrixID,
                              int aiColumnIndex)

      Return and indication of whether the specified column is entirely empty. The column is considered empty if it is beyond the end of the matrix, or if *all* of the cells in the column are empty.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiColumnIndex` - Index of column whose empty state should be tested.
      Returns:
        `true` if the specified row is empty.

    - #### isColumnSelected

          boolean isColumnSelected(Selection aSelection)

      Returns `true`, if a column in any matrix is selected, `false` otherwise.
      Parameters:
        `aSelection` - Selection to test.
      Returns:
        `true` if a column in any matrix selected.

    - #### isEnabledAddColumnsToEnd

          boolean isEnabledAddColumnsToEnd(Selection aSelection)

      Determine whether add columns to end function should be enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if add columns to end function should be enabled.

    - #### isEnabledAddRowsToEnd

          boolean isEnabledAddRowsToEnd(Selection aSelection)

      Determine whether add rows to end function should be enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if add rows to end function should be enabled.

    - #### isEnabledCheckForLogicalLoops

          boolean isEnabledCheckForLogicalLoops(Selection aSelection)

      Determine whether check for logical loops function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledClearAnalysisResults

          boolean isEnabledClearAnalysisResults()

      Determine whether clear analysis results function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledCopy

          boolean isEnabledCopy(Selection aSelection)

      Determine whether copy function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledCut

          boolean isEnabledCut(Selection aSelection)

      Determine whether cut function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledDelete

          boolean isEnabledDelete(Selection aSelection)

      Determine whether delete function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledDeleteColumn

          boolean isEnabledDeleteColumn(Selection aSelection)

      Determine whether delete column function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledDeleteRow

          boolean isEnabledDeleteRow(Selection aSelection)

      Determine whether delete row function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledDisable

          boolean isEnabledDisable(Selection aSelection)

      Determine whether disable function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledExtendToDatabase

          boolean isEnabledExtendToDatabase(Selection aSelection)

      Determine whether extend to database action should be enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledFilterDatabase

          boolean isEnabledFilterDatabase(Selection aSelection)

      Determine whether the "database filter" function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledFilterMinimum

          boolean isEnabledFilterMinimum(Selection aSelection)

      Deprecated. Minimum filters have been superseded by discrete filters.
      Determine whether the "minimum filter" function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledFilterPrecondition

          boolean isEnabledFilterPrecondition(Selection aSelection)

      Determine whether the "precondition" function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledInsertColumn

          boolean isEnabledInsertColumn(Selection aSelection)

      Determine whether insert column function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledInsertRow

          boolean isEnabledInsertRow(Selection aSelection)

      Determine whether insert row function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledLocalize

          boolean isEnabledLocalize()

      Determine whether Localize function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledNaturalLanguageEditorContextMenuAction

          boolean isEnabledNaturalLanguageEditorContextMenuAction()

      Determine whether Natural Language action is enabled for a rulesheet.
      Returns:
        `true` if action should be enabled.

    - #### isEnabledPaste

          boolean isEnabledPaste(Selection aSelection)

      Determine whether paste function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledProcessThreshold

          boolean isEnabledProcessThreshold(Selection aSelection)

      Determine whether "Use Conditions as a processing Threshold" function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledRenumberRules

          boolean isEnabledRenumberRules(Selection aSelection)

      Determine whether renumber rules function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledReport

          boolean isEnabledReport()

      Determine whether report function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledSelectAll

          boolean isEnabledSelectAll()

      Determine whether select all function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isFilterDatabase

          boolean isFilterDatabase(int aiRowIndex)

      Determine whether the specified filter row is a database filter.
      Parameters:
        `aiRowIndex` - Row index.
      Returns:
        `true` if filter row is a database filter.

    - #### isFilterMinimum

          boolean isFilterMinimum(int aiRowIndex)

      Deprecated. Minimum filters have been superseded by discrete filters.
      Determine whether the specified filter row is a minimum filter.
      Parameters:
        `aiRowIndex` - Row index.
      Returns:
        `true` if filter row is a minimum filter.

    - #### isFilterPrecondition

          boolean isFilterPrecondition(int aiRowIndex)

      Determine whether the specified filter row is a precondition
      Parameters:
        `aiRowIndex` - Row index.
      Returns:
        `true` if filter row is a precondition.

    - #### isNaturalLanguageView

          boolean isNaturalLanguageView()

      Determine whether Natural Language view is enabled.
      Returns:
        `true` if the Natural Language view is enabled.

    - #### isRowEmpty

          boolean isRowEmpty(int aiMatrixID,
                           int aiRowIndex)

      Return and indication of whether the specified row is entirely empty. The row is considered empty if it is beyond the end of the matrix, or if *all* of the cells in the row are empty.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiRowIndex` - Index of row whose empty state should be tested.
      Returns:
        `true` if the specified row is empty.

    - #### isRuleColumnAddedByCompletenessCheck

          boolean isRuleColumnAddedByCompletenessCheck(int aiColumnIndex)

      Return `true` if the specified rule column was added by the completeness check service.
      Parameters:
        `aiColumnIndex` - Column index.
      Returns:
        `true` if the specified rule column was added by the completeness check service.

    - #### isRuleColumnAmbiguous

          boolean isRuleColumnAmbiguous(int aiColumnIndex)

      Return `true` if the specified rule column is currently flagged as ambiguous.
      Parameters:
        `aiColumnIndex` - Column index.
      Returns:
        `true` if the specified rule column is currently flagged as ambiguous.

    - #### isRuleColumnHeaderBold

          boolean isRuleColumnHeaderBold(int aiColumnIndex)

      Return `true` if the specified rule column heading should be rendered in bold.
      Parameters:
        `aiColumnIndex` - Column index.
      Returns:
        `true` if the specified rule column heading should be rendered in bold.

    - #### isRuleMatrix

          boolean isRuleMatrix(int aiMatrixID)

      Determine whether the specified matrix is one of the rule matrices, specifically "if", "then" or "overrides".
      Parameters:
        `aiMatrixID` - Matrix ID.
      Returns:
        `true` if matrix is one of the rule matrices.

    - #### isScopeNodeExpanded

          boolean isScopeNodeExpanded(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Determine whether the specified ScopeNode instance is expanded.
      Parameters:
        `aScopeNode` - ScopeNode instance to be tested.
      Returns:
        `true` if element is expanded.

    - #### isScopeNodeFilterDisabledGlobally

          boolean isScopeNodeFilterDisabledGlobally(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter aScopeFilter)

      Determine whether the specified ScopeFilter instance should be rendered as disabled in the scope tree viewer because the filter row is completely disabled.
      Parameters:
        `aScopeFilter` - ScopeFilter node instance.
      Returns:
        `true` if the scope filter is completely disabled.

    - #### isScopeNodeFilterDisabledIndependently

          boolean isScopeNodeFilterDisabledIndependently(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter aScopeFilter)

      Determine whether the specified ScopeFilter instance is disabled independently.
      Parameters:
        `aScopeFilter` - ScopeFilter to be tested.
      Returns:
        `true` if ScopeFilter is disabled discretely.

    - #### isScopeNodeFilterLeaf

          boolean isScopeNodeFilterLeaf(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFilter aScopeFilter)

      Identify whether the given ScopeFilter is a leaf-most filter node in the ScopeNode hierarchy. e.g. for Scope node hierarchy
      Customer + order (association) + item (association) + quantity (attribute)
      and filter expression: Customer.order.item.quantity = 10 The ScopeFilter under the item association would be the leaf-most filter node.
      Parameters:
        `aScopeFilter` - ScopeFilter to be tested.
      Returns:
        true, if the ScopeFilter is the leaf-most filter node, false otherwise.

    - #### isScopeNodeInherited

          boolean isScopeNodeInherited(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Determine whether the specified ScopeNode instance is inherited.
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        `true` if scope node is inherited.

    - #### isScopeNodeNameLightGray

          boolean isScopeNodeNameLightGray(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Determine whether the specified Scope node name should be rendered in light gray text. For associations, only qualified ones are shown in light gray.
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        `true` if node should be rendered using light gray text.

    - #### isScopeNodeQualified

          boolean isScopeNodeQualified(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Determine whether the specified ScopeNode instance is a qualified association.
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        `true` if scope node is a qualified association.

    - #### isScopeNodeScopeFilterMinimum

          boolean isScopeNodeScopeFilterMinimum(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Deprecated. Minimum filters have been superseded by discrete filters.
      Determine whether the specified ScopeNode instance is a ScopeFilter.isMinimum().
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        `true` if scope node is a ScopeFilter.isMinimum().

    - #### isScopeNodeScopeFilterPrecondition

          boolean isScopeNodeScopeFilterPrecondition(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Determine whether the specified ScopeNode instance is a ScopeFilter.isPrecondition().
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        `true` if scope node is a ScopeFilter.isPrecondition().

    - #### isScopeNodeScopeFilterDisabled

          boolean isScopeNodeScopeFilterDisabled(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Determine whether the specified ScopeNode instance is a ScopeFilter.isDisabled().
      Parameters:
        `aScopeNode` - ScopeNode instance.
      Returns:
        `true` if scope node is a ScopeFilter.isDisabled().

    - #### isValidRuleStatementReference

          boolean isValidRuleStatementReference(java.lang.String astrReference)

      Determine whether the the given Rule Statement Reference is of valid syntax. This method will return `true` if the input conforms to allowable Rule Statement Reference syntax and points to existing view model rows and columns.
      Parameters:
        `astrReference` - Rule Statement Reference (e.g., "A0", "1");

    - #### makeActionValueSetCell

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ActionValueSetCell makeActionValueSetCell(java.lang.String astrValue)

      Factory method to create a valid ActionValueSetCell from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        New ActionValueSetCell instance or `null`.

    - #### makeConditionValueSetCell

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ConditionValueSetCell makeConditionValueSetCell(java.lang.String astrValue)

      Factory method to create a valid ConditionValueSetCell from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        New ConditionValueSetCell instance or `null`.

    - #### makeExpressionCell

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ExpressionCell makeExpressionCell(java.lang.String astrValue)

      Factory method to create a valid ExpressionCell from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        New ExpressionCell instance or `null`.

    - #### makeValueSetCell

          com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ValueSetCell makeValueSetCell(java.lang.String astrValue)

      Factory method to create a valid ValueSetCell from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        New ValueSetCell instance or `null`.

    - #### parseAndUpdateAllOverrideCells

          void parseAndUpdateAllOverrideCells()

      Parse and update all override cells.

    - #### parseAndUpdateAllReferenceFields

          void parseAndUpdateAllReferenceFields()

      Parse and update all reference fields, which at this time includes overrides and Rule Statement references. This method can be called whenever a new canonical rule, condition or action is entered to ensure that the object reference lists incorporate the new item.

    - #### parseAndUpdateAllRuleStatementReferenceFields

          void parseAndUpdateAllRuleStatementReferenceFields()

      Parse and rebuild the canonical model for all Rule Statement Reference (Ref) fields.

    - #### parseCell

          void parseCell(int aiMatrixID,
                       int aiColumnIndex,
                       int aiRowIndex)

      Given a matrix ID, column and row indices, parse, semantically analyze and normalize the cell.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Column index.
        `aiRowIndex` - Row index.

    - #### paste

          void paste(Selection aSelection)

      Paste the system clipboard into the selected area.
      Parameters:
        `aSelection` - Selection to copy.

    - #### populateIfCellsWithDashes

          void populateIfCellsWithDashes()

      Automatically fill in empty MATRIX_ID_IF table cells with dashes. This function should be called at save time and before analysis functions.

    - #### presave

          void presave()

      Perform any necessary functions prior to saving.
      Specified by:
        `presave` in interface `IModelAPI`

    - #### rebuildCanonicalRules

          void rebuildCanonicalRules()

      Completely rebuild all canonical rules using information in the view model. This function can be used after functions such as compress or renumber to re-synchronize the view model with the canonical model. When the function is completed, there will be a 1-to-1 correspondence between RuleColumn and PRule instances.

    - #### removeScopeNode

          boolean removeScopeNode(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode)

      Remove an existing node from the Scope section, implicitly deleting all child nodes.
      Parameters:
        `aScopeNode` - Node to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeScopeNodes

          boolean removeScopeNodes(Selection aSelection)

      Remove all existing node from the Scope section that are contained in the Selection, implicitly deleting all child nodes.
      Parameters:
        `aSelection` - All nodes to be removed.
      Returns:
        `true` if the command was successful.

    - #### renumberRules

          boolean renumberRules(Selection aSelection)

      Renumber rules on the input selection.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function was successful.

    - #### reorderFilterChildren

          void reorderFilterChildren(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeFolder aScopeFolder)

      Automatically reorder the filter section.

    - #### selectAll

          void selectAll()

      Select all of the cells in the currently-selected matrix.

    - #### setActionColumnWidthFactor

          boolean setActionColumnWidthFactor(double adWidthFactor)

      Set the actions/values width factor, namely the ratio of the actions column width to the client area width.
      Parameters:
        `adWidthFactor` - Ratio of actions column width to client area width.
      Returns:
        `true` if the set command was successful.

    - #### setActionExpression

          boolean setActionExpression(int aiRowIndex,
                                    java.lang.String astrExpression)

      Set the the action expression at the specified row index.
      Parameters:
        `aiRowIndex` - Index of row whose action should be updated.
        `astrExpression` - Action expression.
      Returns:
        `true` if the set command was successful.

    - #### setActionRowCount

          boolean setActionRowCount(int aiRowCount)

      Set the count of rows in the Actions section. This count must be greater than or equal to the number of ActionItem instances in the ActionSection.
      Parameters:
        `aiRowCount` - Number of rows in the action section of the Rulesheet.
      Returns:
        `true` if the set command was successful.

    - #### setActionScrollRowTop

          boolean setActionScrollRowTop(int aiRowIndexTop)

      Set the action section scroll row top.
      Parameters:
        `aiRowIndexTop` - Index of top row in table.
      Returns:
        `true` if the set command was successful.

    - #### setActionValues

          boolean setActionValues(int aiRowIndex,
                                java.lang.String astrValueSet)

      Set the action values at the specified row index.
      Parameters:
        `aiRowIndex` - Index of row whose action values should be updated.
        `astrValueSet` - Value set in string form.
      Returns:
        `true` if the set command was successful.

    - #### setAdvanceViewVisible

          void setAdvanceViewVisible(boolean visible)

      Set the visibility of the AdvanceView.
      Parameters:
        `visible` - boolean.

    - #### setAmbiguityFilter

          boolean setAmbiguityFilter(boolean abFilter)

      Sets Conflict filter ON/OFF.
      Parameters:
        `abFilter,` - true to turn ON the filter, false otherwise
      Returns:
        `true` if the filter flag is set.

    - #### setCellValue

          boolean setCellValue(int aiMatrixID,
                             int aiColumnIndex,
                             int aiRowIndex,
                             java.lang.Object aObjectValue)

      Set the Rulesheet cell value of the specified matrix, row and column index.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
        `aObjectValue` - Value (e.g., String, Enumerator).
      Returns:
        `true` if the set command was successful.

    - #### setCellValue

          boolean setCellValue(int aiMatrixID,
                             int aiColumnIndex,
                             int aiRowIndex,
                             java.lang.Object aObjectValue,
                             boolean abBase)

      Set the Rulesheet cell value of the specified matrix, row and column index. The caller may supply either a base or localized value.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
        `aObjectValue` - Value to set (e.g., String, Enumerator).
        `abBase` - `true` to supply non-localized (base) string.
      Returns:
        `true` if the set command was successful.

    - #### setColumnCountDisplayed

          boolean setColumnCountDisplayed(int aiMatrixID,
                                        int aiColumnCount)

      Set the number of column displayed in the specified matrix. The count reflects the number of column to be displayed and may be greater than the number of actual columns present in the matrix. Only matrices that support variable column count will actually be affected.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_IF).
        `aiColumnCount` - Column count.

    - #### setConditionAsProcessingThreshold

          boolean setConditionAsProcessingThreshold(int aiColumn,
                                                  boolean abSet)

      Set condition as processing threshold for a given rule column
      Parameters:
        `aiColumn` - Rule column index.
        `abSet` - True to set condition as processing threshold
      Returns:
        `true` if the set command was successful.

    - #### setConditionColumnWidthFactor

          boolean setConditionColumnWidthFactor(double adWidthFactor)

      Set the conditions/values width factor, namely the ratio of the conditions column width to the total column width.
      Parameters:
        `adWidthFactor` - Ratio of conditions column width to total width.
      Returns:
        `true` if the set command was successful.

    - #### setConditionExpression

          boolean setConditionExpression(int aiRowIndex,
                                       java.lang.String astrExpression)

      Set the the condition expression at the specified row index.
      Parameters:
        `aiRowIndex` - Index of row whose condition should be updated.
        `astrExpression` - Condition expression.
      Returns:
        `true` if the set command was successful.

    - #### setConditionRowCount

          boolean setConditionRowCount(int aiRowCount)

      Set the count of rows in the Conditions section. This count must be greater than or equal to the number of ConditionItem instances in the ConditionSection.
      Parameters:
        `aiRowCount` - Number of rows in the condition section of the Rulesheet.
      Returns:
        `true` if the set command was successful.

    - #### setConditionsAsProcessingThreshold

          boolean setConditionsAsProcessingThreshold()

      Toggle selected condition columns as processing threshold.
      Returns:
        `true` if function sets processing threshold

    - #### setConditionScrollRowTop

          boolean setConditionScrollRowTop(int aiRowIndexTop)

      Set the conditions section scroll row top.
      Parameters:
        `aiRowIndexTop` - Index of top row in table.
      Returns:
        `true` if the set command was successful.

    - #### setConditionValues

          boolean setConditionValues(int aiRowIndex,
                                   java.lang.String astrValueSet)

      Set the condition values at the specified row index.
      Parameters:
        `aiRowIndex` - Index of row whose condition should be updated.
        `astrValueSet` - Value set in string form.
      Returns:
        `true` if the set command was successful.

    - #### setFilterExpression

          boolean setFilterExpression(int aiRowIndex,
                                    java.lang.String astrExpression)

      Sets the Filter expression for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row whose expression should be updated.
        `astrExpression` - Filter expression.
      Returns:
        `true` if the set command was successful.

    - #### setFilterDatabase

          boolean setFilterDatabase(int aiRowIndex,
                                  boolean abFilterDatabase)

      Sets the Filter database indicator for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row whose expression should be updated.
        `abMinimum` - `true` to set "database filter" for the specified row.
      Returns:
        `true` if the set command was successful.

    - #### setFilterMinimum

          boolean setFilterMinimum(int aiRowIndex,
                                 boolean abMinimum)

      Deprecated. Minimum filters have been superseded by discrete filters.
      Sets the Filter minimum indicator for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row whose expression should be updated.
        `abMinimum` - `true` to set "minimum filter" for the specified row.
      Returns:
        `true` if the set command was successful.

    - #### setFilterPrecondition

          boolean setFilterPrecondition(int aiRowIndex,
                                      boolean abPrecondition)

      Sets the Filter precondition indicator for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row whose expression should be updated.
        `abPrecondition`true`` - to set the "precondition" state for the specified row.
      Returns:
        `true` if the set command was successful.

    - #### setFilterRowCount

          boolean setFilterRowCount(int aiRowCount)

      Set the count of rows in the Filter section.
      Parameters:
        `aiRowCount` - Number of rows in the Filter section of the Rulesheet.
      Returns:
        `true` if the set command was successful.

    - #### setFilterScrollRowTop

          boolean setFilterScrollRowTop(int aiRowIndexTop)

      Set the Filter section scroll row top.
      Parameters:
        `aiRowIndexTop` - Index of top row in table.
      Returns:
        `true` if the set command was successful.

    - #### setLocalizationLanguageCode

          boolean setLocalizationLanguageCode(int aiRowIndex,
                                            java.lang.String astrLanguageCode)

      Set the localization view language code.
      Parameters:
        `aiRowIndex` - Index of row number whose language code should be updated.
        `astrExpression` - Condition expression.
      Returns:
        `true` if the set command was successful.

    - #### setLocalizationRuleStatementText

          boolean setLocalizationRuleStatementText(int aiColumnIndex,
                                                 int aiRowIndex,
                                                 java.lang.String astrText)

      Set the localization view rule statement text.
      Parameters:
        `aiColumnIndex` - Index of column number whose localization should be updated.
        `aiRowIndex` - Index of row number whose localization should be updated.
        `astrText` - Rule statement text (localized).
      Returns:
        `true` if the set command was successful.

    - #### setLocalizationScopeAlias

          boolean setLocalizationScopeAlias(int aiColumnIndex,
                                          int aiRowIndex,
                                          java.lang.String astrText)

      Set the localization view scope alias.
      Parameters:
        `aiColumnIndex` - Index of column number whose localization should be updated.
        `aiRowIndex` - Index of row number whose localization should be updated.
        `astrText` - Alias in localized form.
      Returns:
        `true` if the set command was successful.

    - #### setNaturalLanguageAction

          boolean setNaturalLanguageAction(int aiColumnIndex,
                                         int aiRowIndex,
                                         java.lang.String astrText)

      Set the specified natural language action cell.
      Parameters:
        `aiColumnIndex` - Index of column number whose localization should be updated.
        `aiRowIndex` - Index of row number whose localization should be updated.
        `astrText` - Natural language text.
      Returns:
        `true` if the set command was successful.

    - #### setNaturalLanguageCondition

          boolean setNaturalLanguageCondition(int aiColumnIndex,
                                            int aiRowIndex,
                                            java.lang.String astrText)

      Set the specified natural language condition cell.
      Parameters:
        `aiColumnIndex` - Index of column number whose localization should be updated.
        `aiRowIndex` - Index of row number whose localization should be updated.
        `astrText` - Natural language text.
      Returns:
        `true` if the set command was successful.

    - #### setNaturalLanguageView

          void setNaturalLanguageView(boolean abNaturalLanguageView)

      Set the Natural Language view state.
      Parameters:
        `aiNaturalLanguageView` - `true` to enable Natural Language view.

    - #### setRowCountDisplayed

          boolean setRowCountDisplayed(int aiMatrixID,
                                     int aiRowCount)

      Set the number of rows displayed in the specified matrix. The count reflects the number of rows to be displayed and may be greater than the number of items in the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `Row` - count.

    - #### setRowHeight

          boolean setRowHeight(int aiMatrixID,
                             int aiRowIndex,
                             int aiRowHeight)

      Set the height of the specified row.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiRowIndex` - Index of row.
        `aiRowHeight` - Height of specified row in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleActionCell

          boolean setRuleActionCell(int aiColumnIndex,
                                  int aiRowIndex,
                                  java.lang.String astrValueSet)

      Set the rule action ("then") cell at the specified column and row indices.
      Parameters:
        `aiColumnIndex` - Index of rule column whose cell should be updated.
        `aiRowIndex` - Index of row whose cell should be updated.
        `astrValueSet` - Value set in string form.
      Returns:
        `true` if the set command was successful.

    - #### setRuleActionCellInternal

          boolean setRuleActionCellInternal(int aiColumnIndex,
                                          int aiRowIndex,
                                          ValueSet aValueSet,
                                          boolean abCanonical)

      Set the rule action ("then") cell at the specified column and row indices. This high-performance function does the minimum possible model-level changes, bypassing all unnecessary processing.
      Parameters:
        `aiColumnIndex` - Index of rule column whose cell should be updated.
        `aiRowIndex` - Index of row whose cell should be updated.
        `aValueSet` - ValueSet instance.
        `abCanonical` - Add PRule to canonical model also.
      Returns:
        `true` if the set command was successful.

    - #### setRuleColumnCount

          boolean setRuleColumnCount(int aiColumnCount)

      Set the count of rule columns. This count must be greater than or equal to the number of RuleColumn instances in the Rule section.
      Parameters:
        `aiColumnCount` - Number of rule columns in the Rulesheet.
      Returns:
        `true` if the set command was successful.

    - #### setRuleColumnWidth

          boolean setRuleColumnWidth(int aiRuleColumnIndex,
                                   int aiWidth)

      Set the width of a rule column.
      Parameters:
        `aiRuleColumnIndex` - Rule column index.
        `aiWidth` - Width of rule column in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleColumnWidthAutoSize

          boolean setRuleColumnWidthAutoSize(int aiRuleColumnIndex)

      Set the width of a rule column with auto-sizing. This method will calculate the optimum width automatically based on the contents of the cells.
      Parameters:
        `aiRuleColumnIndex` - Rule column index.
      Returns:
        `true` if the set command was successful.

    - #### setRuleConditionCell

          boolean setRuleConditionCell(int aiColumnIndex,
                                     int aiRowIndex,
                                     java.lang.String astrValueSet)

      Set the rule condition ("if") cell at the specified column and row indices.
      Parameters:
        `aiColumnIndex` - Index of rule column whose cell should be updated.
        `aiRowIndex` - Index of row whose cell should be updated.
        `astrValueSet` - Value set in string form.
      Returns:
        `true` if the set command was successful.

    - #### setRuleConditionCellInternal

          boolean setRuleConditionCellInternal(int aiColumnIndex,
                                             int aiRowIndex,
                                             ValueSet aValueSet,
                                             boolean abCanonical)

      Set the rule condition ("if") cell at the specified column and row indices. This high-performance function does the minimum possible model-level changes, bypassing all unnecessary processing.
      Parameters:
        `aiColumnIndex` - Index of rule column whose cell should be updated.
        `aiRowIndex` - Index of row whose cell should be updated.
        `aValueSet` - ValueSet instance.
        `abCanonical` - Add PRule to canonical model also.
      Returns:
        `true` if the set command was successful.

    - #### setRuleIDs

          boolean setRuleIDs(java.lang.String[] astrRuleIDArray)

      Set the rule identifiers from a caller-supplied array.
      Parameters:
        `astrRuleIDArray` - Array (String) of rule identifiers.
      Returns:
        `true` if the set command was successful.

    - #### setRuleOverrideCell

          boolean setRuleOverrideCell(int aiColumnIndex,
                                    java.lang.String astrValueSet)

      Set the rule override cell at the specified column index.
      Parameters:
        `aiColumnIndex` - Index of rule column whose override cell should be updated.
        `astrValueSet` - Value set in string form.
      Returns:
        `true` if the set command was successful.

    - #### setRuleOverrideCellInternal

          boolean setRuleOverrideCellInternal(int aiColumnIndex,
                                            ValueSet aValueSet,
                                            boolean abCanonical)

      Set the rule override cell at the specified column index. This high-performance function does the minimum possible model-level changes, bypassing all unnecessary processing.
      Parameters:
        `aiColumnIndex` - Index of rule column whose cell should be updated.
        `aValueSet` - ValueSet instance.
        `abCanonical` - Add PRule to canonical model also.
      Returns:
        `true` if the set command was successful.

    - #### setRuleScrollColumnLeft

          boolean setRuleScrollColumnLeft(int aiColumnIndexLeft)

      Set the rule section scroll column left.
      Parameters:
        `aiColumnIndexLeft` - Index of left most column displayed in table.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementAlias

          boolean setRuleStatementAlias(int aiRowIndex,
                                      java.lang.String astrAlias)

      Set the rule statement Alias for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrAlias` - Alias (e.g., Order.item).
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementCategory

          boolean setRuleStatementCategory(int aiRowIndex,
                                         java.lang.String astrCategory)

      Set the rule statement Category for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrCategory` - Rule statement Category.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthAlias

          boolean setRuleStatementColumnWidthAlias(int aiWidth)

      Set the rule statement Alias column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthCategory

          boolean setRuleStatementColumnWidthCategory(int aiWidth)

      Set the rule statement Category column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthComments

          boolean setRuleStatementColumnWidthComments(int aiWidth)

      Set the rule statement Comments column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthID

          boolean setRuleStatementColumnWidthID(int aiWidth)

      Set the rule statement ID column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthPostSeverity

          boolean setRuleStatementColumnWidthPostSeverity(int aiWidth)

      Set the rule statement Post Severity column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthReference

          boolean setRuleStatementColumnWidthReference(int aiWidth)

      Set the rule statement Reference column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthRuleLink

          boolean setRuleStatementColumnWidthRuleLink(int aiWidth)

      Set the rule statement Rule Link column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthRuleName

          boolean setRuleStatementColumnWidthRuleName(int aiWidth)

      Set the rule statement Rule Name column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthSourceLink

          boolean setRuleStatementColumnWidthSourceLink(int aiWidth)

      Set the rule statement Source Link column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthSourceName

          boolean setRuleStatementColumnWidthSourceName(int aiWidth)

      Set the rule statement Source Name column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementColumnWidthText

          boolean setRuleStatementColumnWidthText(int aiWidth)

      Set the rule statement Text column width.
      Parameters:
        `aiWidth` - Width in pixels.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementComments

          boolean setRuleStatementComments(int aiRowIndex,
                                         java.lang.String astrComments)

      Set the rule statement Comments for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrComments` - Rule statement Comments.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementID

          boolean setRuleStatementID(int aiRowIndex,
                                   java.lang.String astrID)

      Sets the rule statement ID for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrRuleStatementID` - Rule statement ID.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementPostSeverity

          boolean setRuleStatementPostSeverity(int aiRowIndex,
                                             com.corticon.rulesemf.canonicalrulemodel.rulesheet.MessageSeverity aMessageSeverity)

      Deprecated. - Should use setRuleStatementPostSeverity(int, String)
      Sets the rule statement Post Severity for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `aMessageSeverity` - MessageSeverity enumerated value.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementPostSeverity

          boolean setRuleStatementPostSeverity(int aiRowIndex,
                                             java.lang.String astrBaseSeverityName)

      Sets the rule statement Post Severity for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrBaseSeverityName` - Base value string.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementReference

          boolean setRuleStatementReference(int aiRowIndex,
                                          java.lang.String astrReference)

      Sets the rule statement Reference for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrReference` - Rule statement Reference.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementRowCount

          boolean setRuleStatementRowCount(int aiRowCount)

      Set the count of rows in the Rule Statement section.
      Parameters:
        `aiRowCount` - Number of rows in the Rule Statement section of the Rulesheet.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementRuleLink

          boolean setRuleStatementRuleLink(int aiRowIndex,
                                         java.lang.String astrRuleLink)

      Set the rule statement Rule Link for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrRuleLink` - Rule statement Rule Link.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementRuleName

          boolean setRuleStatementRuleName(int aiRowIndex,
                                         java.lang.String astrRuleName)

      Set the rule statement Rule Name for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrRuleName` - Rule statement Rule Name.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementScrollRowTop

          boolean setRuleStatementScrollRowTop(int aiRowIndexTop)

      Set the rule statement section scroll row top.
      Parameters:
        `aiRowIndexTop` - Index of top row in table.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementSourceLink

          boolean setRuleStatementSourceLink(int aiRowIndex,
                                           java.lang.String astrSourceLink)

      Set the rule statement Source Link for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrSourceLink` - Rule statement Source Link.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementSourceName

          boolean setRuleStatementSourceName(int aiRowIndex,
                                           java.lang.String astrSourceName)

      Set the rule statement Source Name for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrSourceName` - Rule statement Source Name.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementText

          boolean setRuleStatementText(int aiRowIndex,
                                     java.lang.String astrText)

      Set the rule statement Text for the specified row index.
      Parameters:
        `aiRowIndex` - Index of row rule statement row.
        `astrText` - Rule statement Text.
      Returns:
        `true` if the set command was successful.

    - #### setSashWeightAdvancedView

          void setSashWeightAdvancedView(int aiNewSashWeightAdvancedView)

      Sets the value of the sash weight for Advanced View.
      Parameters:
        `aiNewSashWeightAdvancedView` - Sash weight value for the Advanced View.

    - #### setSashWeightConditionsActions

          void setSashWeightConditionsActions(int aiNewSashWeightConditionsActions)

      Sets the value of the sash weight for Conditions/Actions Section.
      Parameters:
        `aiNewSashWeightConditionsActions` - Sash weight value for the Conditions/Actions Section

    - #### setSashWeightConditionsIf

          void setSashWeightConditionsIf(int aiNewSashWeightConditionsIf)

      Sets the value of the sash weight for Conditions/If Section.
      Parameters:
        `aiNewSashWeightConditionsIf` - Sash weight value for the Conditions/If Section.

    - #### setSashWeightScope

          void setSashWeightScope(int aiNewSashWeightScope)

      Sets the value of the sash weight for Scope Section.
      Parameters:
        `aiNewSashWeightScope` - Sash weight value for the Scope Section

    - #### setScopeAlias

          boolean setScopeAlias(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias,
                              java.lang.String astrAlias)

      Set the Scope alias in a given ScopeAlias node.
      Parameters:
        `aScopeAlias` - ScopeAlias instance.
        `astrAlias` - Alias as string.
      Returns:
        boolean instance.

    - #### setScopeExtendToDatabase

          boolean setScopeExtendToDatabase(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeEntity aScopeEntity,
                                         boolean abExtendToDatabase)

      Set the Scope extend to database flag.
      Parameters:
        `aScopeEntity` - ScopeEntity instance.
        `abExtendToDatabase` - Extend to database flag `true` or `false`.
      Returns:
        `true` if the set command was successful.

    - #### setScopeNodeAliasName

          boolean setScopeNodeAliasName(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeAlias aScopeAlias,
                                      java.lang.String astrAlias)

      Set the Scope alias for a given ScopeAlias node. The supplied value is expected to be in localized form.
      Parameters:
        `aScopeAlias` - ScopeAlias instance.
        `astrAlias` - Alias as localized string.
      Returns:
        `true` if the set command was successful.

    - #### setScopeNodeExpanded

          boolean setScopeNodeExpanded(com.corticon.rulesemf.viewrulemodel.rulesheet.decisiontable.ScopeNode aScopeNode,
                                     boolean abExpanded)

      Sets the value of expanded attribute of the specified ScopeNode instance.
      Parameters:
        `aScopeNode` - ScopeNode instance, whose expanded attribute is to set.
        `abExpanded` - `true` if element is expanded.
      Returns:
        `true` if the set command was successful.

    - #### setScrollRowTop

          boolean setScrollRowTop(int aiMatrixID,
                                int aiRowIndexTop)

      Set the index of the top row that is currently displayed in the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_CONDITIONS).
        `aiRowIndexTop` - Index of top row in table.
      Returns:
        `true` if the set command was successful.

    - #### setSelection

          boolean setSelection(Selection aSelection)

      Set the selection state.
      Parameters:
        `aSelection` - Selection instance bearing selection state information.
      Returns:
        `true` if the set command was successful.

Copyright © 2005-2013 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.